/**
 *  Saturn Save Data Manager
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/
#ifndef _BUP_APP_TITLE_H_
#define _BUP_APP_TITLE_H_

/*
 * Save Data Manager application title set in IP header.
 * This is used in order to verify if application is loaded
 * from CD-ROM or SD card.
 *
 * This is also used in order to get a constant IP header CRC
 * value for this application.
 */
#define BUP_APP_TITLE_STR "SATURN SAVE DATA MANAGER"
#define BUP_APP_TITLE_LEN 24

/* CRC value of the title string above, used when verifying
 * if IP header is from Save Data Manager or not.
 */
#define BUP_APP_TITLE_CRC 0x157E3779

/* Dummy, but constant IP header CRC value returned by
 * ip_header_get_crc function when Save Data Manager
 * is detected.
 */
#define BUP_APP_IPHDR_CRC 0xCAFE0100


/*
 * Parameter structure for program debug purpose, 
 * or maybe more if motivated enough.
 */
typedef struct _bupmngr_params_t
{
    /* 0x060FFF00 */
    unsigned short magic_cafe;
    /* 0x060FFF02~ */
    unsigned char reserved[14];

    /* 0x060FFF10 */
    unsigned short vmem_dbg_mode;
} bupmngr_params_t;
#define BUP_PARAM_STRUCT ((bupmngr_params_t*)0x060FFF00)


#endif /* _BUP_APP_TITLE_H_ */
