/**
 *  Saturn Save Data Manager
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/
/*
 * Sega Saturn cartridge flash tool
 * by Anders Montonen, 2012
 *
 * Original software by ExCyber
 * Graphics routines by Charles MacDonald
 *
 * Creative Commons Attribution-ShareAlike 3.0 Unported (CC BY-SA 3.0)
 */
#ifndef _BUP_FUNCTIONS_H_
#define _BUP_FUNCTIONS_H_

#include <stdio.h>
#include <string.h> // For memset,memcpy

/* Saturn related includes. */
#include <sc_saturn.h>

/**
 * bup_display_contents
 * Display some informations about specified save data.
**/
void bup_display_contents(BupDir* tb, unsigned char* data);


/**
 * bup_copymove
 * Prompt and copy/move data specified by user.
**/
void bup_copymove(int move_data);


/**
 * bup_delete
 * Prompt and delete data specified by user.
**/
void bup_delete(void);


/**
 * bup_format
 * Prompt and format device specified by user.
**/
void bup_format(void);


/**
 * bup_devinfo
 * Prompt and show information about device specified by user.
**/
void bup_devinfo(void);

/**
 * bup_copymove
 * Prompt for a save data and show its contents.
**/
void bup_hexedit(void);


#endif /* _BUP_FUNCTIONS_H_ */

