/**
 *  Saturn Save Data Manager
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#include "extra_menu.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// dirty fix for using rand() function.
int rand (void);

#include <sc_saturn.h>

#include "bup_menus.h"

#include "../conio.h"
#include "../debug_console.h"
#include "../filebrowser.h"
#include "../menu.h"
#include "../soft_reset.h"
#include "../starfield.h"
#include "../logo.h"
#include "../vdp.h"

/* Declaration of menu shared variables.
 * And declaration of function to init satcom library.
 */
#include "main.h"


int sf_count = STARS_MAXCOUNT;
int sf_color = 0;


int extra_wait_for_start(char* msg)
{
    pad_t* pad;

    conio_printf(2, 25, COLOR_TRANSPARENT, empty_line);
    if(msg)
    {
        conio_printf(2, 25, COLOR_WHITE, "%s", msg);
    }
    else
    {
        conio_printf(2, 25, COLOR_WHITE, "Press Start to continue");
    }

    /* Wait until user releases start button. */
    while(1)
    {
        /* Wait for V-Blank. */
        WaitForVBLANKIn();
        WaitForVBLANKOut();

        /* Poll joypad */
        pad = pad_read();
        if((pad->new[0] & PAD_START) == 0)
        {
            break;
        }

        /* Animate starfield. */
        bup_anim_starfield();
    }


    while(1)
    {
        WaitForVBLANKIn();
        WaitForVBLANKOut();

        pad = pad_read();
        if(pad->delta[0] & PAD_START)
        {
            break;
        }

        /* Animate starfield. */
        bup_anim_starfield();
    }

    conio_printf(2, 25, COLOR_TRANSPARENT, empty_line);

    return 1;
}




int _palmodif_col = 0;
int _palmodif_row = 16;
void extra_palmodif_keypress(pad_t* pad, int initial_release_wait, int stag)
{
    volatile unsigned short *vdp2_cram = (volatile unsigned short *)VDP2_CRAM;
    int id;

    if(pad)
    {
        if(pad->delta[0] & PAD_LEFT)
        {
            if(_palmodif_col != 0)
            {
                _palmodif_col = _palmodif_col-1;
            }
        }
        else if(pad->delta[0] & PAD_RIGHT)
        {
            if(_palmodif_col != 2)
            {
                _palmodif_col = _palmodif_col+1;
            }
        }
        // else if(pad->delta & PAD_UP)
        // {
            // if(_palmodif_row != 16)
            // {
                // _palmodif_row--;
            // }
            // else
            // {
                // _palmodif_row = 31;
            // }
        // }
        // else if(pad->delta & PAD_DOWN)
        // {
            // if(_palmodif_row != 31)
            // {
                // _palmodif_row++;
            // }
            // else
            // {
                // _palmodif_row = 16;
            // }
        // }
    }

    /* Display palette configuration. */
    for(id=0; id<16; id++)
    {
        char sel[6];
        unsigned short col = vdp2_cram[16+id];

        sel[0] = ' '; sel[1] = ' ';
        sel[2] = ' '; sel[3] = ' ';
        sel[4] = ' '; sel[5] = ' ';
        if((16+id) == _palmodif_row)
        {
            sel[_palmodif_col*2+0] = 26; sel[_palmodif_col*2+1] = 27;
        }

        conio_font_printf(FONT_DEFAULT, FONT_CODEPAGE_JAPANESE, 14*MENU_CHAR_W, 4*CONIO_CHAR_H+MENU_CHAR_H*(1+id), 1/*white*/, 
            "R=%c%2d%c, G=%c%2d%c, B=%c%2d%c", 
            sel[0], (col>> 0)&0x1F, sel[1], 
            sel[2], (col>> 5)&0x1F, sel[3], 
            sel[4], (col>>10)&0x1F, sel[5]);
    }
}


void extra_palmodif_change(void)
{
    volatile unsigned short *vdp2_cram = (volatile unsigned short *)VDP2_CRAM;
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;
    int menu_selected = 16;

    _palmodif_col = 0;
    _palmodif_row = menu_selected;
    extra_palmodif_keypress(NULL, 0, 0);

    while(1)
    {
        menu_reset_settings(mset);
        menu_set_callback_vblank(mset, bup_anim_starfield);
        menu_set_callback_keypress(mset, extra_palmodif_keypress);

        menu_set_title(mset, "PalModif");
        menu_set_pos(mset, 3*CONIO_CHAR_W/*x0*/, 4*CONIO_CHAR_H/*y0*/, 11/*w*/, 0/*h*/, 1/*cols*/);
        //menu_set_erase_on_exit(mset, 1);
        menu_set_features(mset, MENU_FEATURES_CHANGEPAGE | MENU_FEATURES_TEXTCENTER);

        menu_reset_items(mitems);
        menu_add_item(mitems, "BLACK  ", 16/*tag*/);
        menu_add_item(mitems, "BLUE   ", 17/*tag*/);
        menu_add_item(mitems, "GREEN  ", 18/*tag*/);
        menu_add_item(mitems, "TEAL   ", 19/*tag*/);
        menu_add_item(mitems, "RED    ", 20/*tag*/);
        menu_add_item(mitems, "PURPLE ", 21/*tag*/);
        menu_add_item(mitems, "MAROON ", 22/*tag*/);
        menu_add_item(mitems, "SILVER ", 23/*tag*/);
        menu_add_item(mitems, "GRAY   ", 24/*tag*/);
        menu_add_item(mitems, "AQUA   ", 25/*tag*/);
        menu_add_item(mitems, "LIME   ", 26/*tag*/);
        menu_add_item(mitems, "OLIVE  ", 27/*tag*/);
        menu_add_item(mitems, "FUCHSIA", MENU_TAG_GREYOUT/*28*//*tag*/);
        menu_add_item(mitems, "PINK   ", 29/*tag*/);
        menu_add_item(mitems, "YELLOW ", 30/*tag*/);
        menu_add_item(mitems, "WHITE  ", 31/*tag*/);

        /* Display Fuschia as grey out item, and Pink as disabled item. */
        menu_disable_item(mitems, 29);

        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);

        if(mset->exit_code == MENU_EXIT_CANCEL)
        {
            clear_screen();
            return;
        }

        /* Select a new color. */
        //_palmodif_col = 0;
        _palmodif_row = menu_selected;

        unsigned short col = vdp2_cram[_palmodif_row];
        unsigned char rgb[3];

        rgb[0] = (col>> 0)&0x1F;
        rgb[1] = (col>> 5)&0x1F;
        rgb[2] = (col>>10)&0x1F;

        if(mset->exit_code == MENU_EXIT_NEXTPAGE_SHOULDER)
        {
            if(rgb[_palmodif_col] != 31)
            {
                rgb[_palmodif_col]++;
                vdp2_cram[_palmodif_row] = COLOR_RGB16(rgb[0], rgb[1], rgb[2]);
                // extra_palmodif_keypress(NULL, 0, 0);
            }
        }
        else if(mset->exit_code == MENU_EXIT_PREVPAGE_SHOULDER)
        {
            if(rgb[_palmodif_col] != 0)
            {
                rgb[_palmodif_col]--;
                vdp2_cram[_palmodif_row] = COLOR_RGB16(rgb[0], rgb[1], rgb[2]);
                // extra_palmodif_keypress(NULL, 0, 0);
            }
        }

        /* Refresh RGB values display. */
        extra_palmodif_keypress(NULL, 0, 0);
    }
}



/**
 * vmem_delete_test
 *
 * vmem_test_bench internal function.
 * Delete save with specified ID.
 * Returns 1 if operation succeded, zero else.
**/
#define VMEM_TB_SAVE_PREFIX "TST"
#define VMEM_TB_SAVE_NAME   VMEM_TB_SAVE_PREFIX "%08X"
int vmem_delete_test(unsigned char device_id, unsigned long save_id, int be_silent)
{
    Sint32 ret;
    char filename[12];

    sprintf(filename, VMEM_TB_SAVE_NAME, (unsigned int)save_id);
    ret = BUP_Delete((Uint32)device_id, (Uint8*)filename);
    if(ret != 0)
    {
        if(!be_silent)
        {
            cons_printf(COLOR_ERROR, "ERROR: delete failure !");
            cons_printf(COLOR_ERROR, "save_id:%d, name:%s", save_id, filename);
        }
        return 0;
    }

    return 1;
}

/**
 * vmem_access_test
 *
 * vmem_test_bench internal function.
 * Test write -> verify -> read access of backup device.
 * Returns 1 if operation succeded, zero else.
**/
#define VMEM_TEST_WRITE_FLAG         (1 << 0)
#define VMEM_TEST_READ_FLAG          (1 << 1)
#define VMEM_TEST_VERIF_FLAG         (1 << 2)
#define VMEM_TEST_SILENT_WRITE_FLAG  (1 << 3)
#define VMEM_TEST_CRC_COMMENT_FLAG   (1 << 4)
int vmem_access_test(unsigned long flags, unsigned char device_id, unsigned long save_id, unsigned char* data, unsigned long datalen, int delete_save, unsigned char* tmp_buff)
{
    Sint32 ret;
    BupDir bupDirData;
    BupDir* tb = &bupDirData;

    memset((void*)tb, 0, sizeof(BupDir));
    sprintf((char*)(tb->filename), VMEM_TB_SAVE_NAME, (unsigned int)save_id);
    if(flags & VMEM_TEST_CRC_COMMENT_FLAG)
    {
        /* Indicate save data CRC in comment.
         * This will be used to verify save data integrity.
         * Comment length is 10 characters, so that format is "C=12345678".
         */
        unsigned long crc = crc32_calc((const void *)data, datalen);
        sprintf((char*)(tb->comment), "C=%08X", (unsigned int)crc);
    }
    else
    {
        /* Simple comment indicating save data length. */
        sprintf((char*)(tb->comment), "len:%6d", (unsigned int)datalen);
    }
    tb->language = BUP_ENGLISH;
    tb->date = 0;//bup_get_saturn_date();
    tb->datasize = datalen;

    if(flags & (VMEM_TEST_WRITE_FLAG|VMEM_TEST_SILENT_WRITE_FLAG))
    {
        ret = BUP_Write((Uint32)device_id, tb, (volatile Uint8*)data, 0/* overwrite check */);
        if(ret != 0)
        {
            if(flags & VMEM_TEST_SILENT_WRITE_FLAG)
            {
                /* Silent write. */
            }
            else
            {
                cons_printf(COLOR_ERROR, "ERROR: write failure !");
                cons_printf(COLOR_ERROR, "save_id:%d", save_id);
                cons_printf(COLOR_ERROR, "datalen:%d bytes", datalen);
            }
            return 0;
        }
    }

    if(flags & VMEM_TEST_READ_FLAG)
    {
        memset(tmp_buff, 0x00, datalen);

        ret = BUP_Read((Uint32)device_id, tb->filename, (volatile Uint8*)tmp_buff);
        if(ret != 0)
        {
            cons_printf(COLOR_ERROR, "ERROR: read failure !");
            cons_printf(COLOR_ERROR, "save_id:%d", save_id);
            cons_printf(COLOR_ERROR, "datalen:%d bytes", datalen);
            return 0;
        }

        if(flags & VMEM_TEST_VERIF_FLAG)
        {
            if(memcmp(data, tmp_buff, datalen) != 0)
            {
                cons_printf(COLOR_ERROR, "ERROR: data corruption !");
                cons_printf(COLOR_ERROR, "save_id:%d", save_id);
                cons_printf(COLOR_ERROR, "datalen:%d bytes", datalen);
                return 0;
            }
        }
    }

    if(flags & VMEM_TEST_VERIF_FLAG)
    {
        ret = BUP_Verify((Uint32)device_id, tb->filename, (volatile Uint8*)data);
        if(ret != 0)
        {
            cons_printf(COLOR_ERROR, "ERROR: verify failure !");
            cons_printf(COLOR_ERROR, "save_id:%d", save_id);
            cons_printf(COLOR_ERROR, "datalen:%d bytes", datalen);
            return 0;
        }
    }

    if(delete_save)
    {
        if(!vmem_delete_test(device_id, save_id, 0/*be_silent*/))
        {
            return 0;
        }
    }

    return 1;
}

/**
 * vmem_test_bench
 *
 * Test (correct) behavior of write/read/verify operations
 * on internal backup memory device.
**/
void vmem_test_bench(void)
{
#define VMEM_TP_MAXLEN (512*1024)
    Sint32 ret;
    const unsigned char device_id = DEVICE_ID_BRAM;
    unsigned char* input_buffer  = (unsigned char*)BUP_BUFFER_ADR;
    unsigned char* temp_buffer = ((unsigned char*)BUP_BUFFER_ADR + VMEM_TP_MAXLEN);
    unsigned long input_crc;
    int i;

    /* Initialize and enable console display. */
#define VMEM_TB_CONS_Y0 6
#define VMEM_TB_CONS_HEIGHT (25-VMEM_TB_CONS_Y0)
    cons_enable(VMEM_TB_CONS_Y0, VMEM_TB_CONS_HEIGHT, 0/*pause_enable*/);

    /* Setup test pattern in input data. */
    cons_printf(COLOR_BG_FG(COLOR_BLACK, COLOR_LIME), "Setup test pattern ...");
    memset(input_buffer, 0, VMEM_TP_MAXLEN);
    for(i=0; i<VMEM_TP_MAXLEN; i+=sizeof(unsigned short))
    {
        unsigned char* ptr1;
        ptr1 = (unsigned char*)(input_buffer+i);
        ptr1[0] = ((i/sizeof(unsigned short))*19) & 0xFF;
        ptr1[1] = ((i/sizeof(unsigned short))*17) & 0xFF;
    }
    for(i=0; i<VMEM_TP_MAXLEN; i+=16)
    {
        unsigned short* ptr2 = (unsigned short*)(input_buffer+i);
        *ptr2 = i/16;
    }

    /* Compute CRC of input data, in order to
     * be sure that BUP library doesn't corrupts it.
     */
    input_crc = crc32_calc((const void *)input_buffer, VMEM_TP_MAXLEN);
    scd_logout("Done. CRC = 0x%08X", input_crc);


    /* Test backup memory access with several input data size patterns :
     *
     * Pattern #0: 
     *  - Constant data size, 512 bytes, 40 times.
     *
     * Pattern #1: 
     *  - Increasing data size, 10 bytes initially.
     *  - 17 bytes added on each time.
     *  - 50 times
     *
     * Pattern #2: 
     *  - Increasing data size, 10 bytes initially.
     *  - 23 bytes added on each time.
     *  - Only save with odd ID is deleted.
     *  - 67 times
     *  - Last (largest) save not deleted, in order to verify free size.
     *
     * Pattern #3: 
     *  - First 5 saves sized between 30~60 bytes.
     *  - Next 500 saves sized between 28 bytes and 28KB, deleted each time.
     *  - Last (largest) save not deleted, in order to verify free size.
     * 
     * Pattern #4: 
     *  - Increasing data size, 1 byte initially.
     *  - 1 byte added on each time for first 170 saves, then 97 bytes added each time.
     *  - One old save out of two deleted for first 170 saves, then all next saves deleted.
     *    (At 170th save, free space is around 13KB, hence BRAM should be relatively well fragmented)
     *  - 250 times
     *  - Last (largest) save not deleted, in order to verify free size.
     * 
     */
    unsigned long save_cnt_tbl[10] = {40, 50, 67, 505, 300, 0};
    unsigned long data_total_len = 0;

    conio_printf( 2, 4, COLOR_WHITE , "Pattern:   , ID:     , LEN:         ");

    /* Count-up tests from all patterns, for display of progress bar. */
    int pat_id = 0;
    unsigned long save_whole_cnt = 0;
    while(save_cnt_tbl[pat_id] != 0)
    {
        save_whole_cnt += save_cnt_tbl[pat_id];
        pat_id++;
    }

    pat_id = 0;
    unsigned long save_whole_id = 0;
    while(save_cnt_tbl[pat_id] != 0)
    {
        /* Show pattern ID on screen. */
        conio_printf(10, 4, COLOR_YELLOW, "%2d", pat_id);

        /* Format backup memory before starting current pass. */
        ret = BUP_Format((Uint32)device_id);
        if(ret != 0)
        {
            cons_printf(COLOR_ERROR, "ERROR: format failure !");
            return;
        }

        unsigned long offset = 0;
        unsigned long save_cnt = save_cnt_tbl[pat_id];
        unsigned long save_id;
        for(save_id=0; save_id<save_cnt; save_id++)
        {
            unsigned long datalen = 123;
            int delete_save = 1;

            /* Show progress information on screen. */
            conio_printf(18, 4, COLOR_YELLOW, "%5d", save_id);
            conio_drawprogress(
                2*CONIO_CHAR_W, 5*CONIO_CHAR_H, 
                36*CONIO_CHAR_W, 1*CONIO_CHAR_H, 
                save_whole_cnt, save_whole_id);

            if(pat_id == 0)
            {
                datalen = 512;
                delete_save = 0;
            }
            else if(pat_id == 1)
            {
                datalen = 10 + 17*save_id;
                delete_save = 0;
            }
            else if(pat_id == 2)
            {
                datalen = 10 + 23*save_id;
                delete_save = save_id % 2;
            }
            else if(pat_id == 3)
            {
                if(save_id < 5)
                {
                    datalen = 30 + save_id*7;
                    delete_save = 0;
                }
                else
                {
                    datalen = 28 + (save_id-5) * 57;
                    delete_save = (save_id == (save_cnt-1) ? 0 : 1);
                }
            }
            else if(pat_id == 4)
            {
                if(save_id < 170)
                {
                    datalen = 1 + save_id;
                    delete_save = 0;
                }
                else
                {
                    datalen = 170 + (save_id-170) * 97;
                    delete_save = (save_id == (save_cnt-1) ? 0 : 1);
                }
            }

            int error_happen = 0;

            unsigned long test_flag = VMEM_TEST_WRITE_FLAG | VMEM_TEST_READ_FLAG | VMEM_TEST_VERIF_FLAG;
            if(!vmem_access_test(test_flag, device_id, save_id, input_buffer+offset, datalen, delete_save, temp_buffer))
            {
                cons_printf(COLOR_ERROR, "Backup memory access failure.");
                error_happen = 1;
            }

            /* Test pattern #4 : delete old save, in order to check file system fragmentation. */
            if(pat_id == 4)
            {
                if((save_id > 5) && (save_id < 170) && ((save_id % 2) == 0))
                {
                    if(!vmem_delete_test(device_id, save_id / 2, 0/*be_silent*/))
                    {
                        cons_printf(COLOR_ERROR, "Backup memory delete failure.");
                        error_happen = 1;
                    }
                }
            }

            if(error_happen)
            {
                /* Dump everything to PC. */
                if(sc_get_dbg_buff()->dbg_on)
                {
                    bup_satcom_init();
                    scf_write(input_buffer+offset, datalen, SC_FILE_PC, "/VMEM_TB_IN.BIN");
                    scf_write(temp_buffer, datalen, SC_FILE_PC, "/VMEM_TB_OUT.BIN");
                    for(i=0; i<(32*1024); i++)
                    {
                        temp_buffer[i] = *((unsigned char*)(0x00180000 + i*2 + 1));
                    }
                    scf_write(temp_buffer, 32*1024, SC_FILE_PC, "/VMEM_TB_BRAM.BIN");
                    scd_logout("Data dumped to PC");
                }
                return;
            }

            /* Display total length of data processed so far. */
            data_total_len += datalen;
            conio_printf(29, 4, COLOR_YELLOW, "%08X", data_total_len);

            /* Change input data on next backup memory access. */
            if((offset + datalen + 256*1024) >= VMEM_TP_MAXLEN)
            {
                offset = 0;
            }
            else
            {
                offset += datalen;
            }

            save_whole_id++;
        } /* Save loop. */

        /* Current pattern ended. Display backup memory usage information. */
        BupStat bupStat;
        memset(&bupStat, 0, sizeof(BupStat));
        BUP_Stat(device_id, 0, &bupStat);
        scd_logout("[%2d]Free %6d B, %5d blk", pat_id, bupStat.freesize, bupStat.freeblock);

        /* Jump to next test pattern. */
        pat_id++;
    } /* Pattern loop. */


    /* verify that BUP library didn't broke input data. */
    if(crc32_calc((const void *)input_buffer, VMEM_TP_MAXLEN) != input_crc)
    {
        cons_printf(COLOR_ERROR, "ERROR: input data is corrupted");
        return;
    }

    /* Wipe backup memory (contents are not interesting since all test passed). */
    BUP_Format((Uint32)device_id);
    cons_printf(COLOR_BG_FG(COLOR_BLACK, COLOR_LIME), "Backup memory test passed !");
}


/**
 * bakcart_test_fill
 *
 * Test write access on backup memory cartridge device.
 *
 * Very similar to vmem_test_bench ... but different. Main difference
 * is of course the change of target backup device, but also the fact that
 * the amount of data stored in backup memory is kept as high as possible.
 * Also, data writing and integrity checking are separated because the purpose
 * of this test bench is to verify that backup memory contents is not corrupted
 * when being loaded a bit after Saturn startup.
 * Finally, there are some other minor differences. All these differences are
 * the reason why this function is separated from vmem_test_bench.
 *
 * Phase 1/2 : fill the cartridge with random data + CRC, and sometimes
 *             delete an old save to make filling interval a bit longer
 *             than simple writing.
 * Phase 2/2 : read back each saves and verify their CRCs. If it mismatch
 *             then there was probably a problem when streaming data to write !
 *
 * [Notes about phase 1/2]
 * As this may write more data than the cartridge may handle, oldest save data
 * is erased when one of the following conditions is met :
 *  - Save data write failure
 *    (= the simplest way to detect if there was enough space remaining in cart)
 *  - More than 200 saves stored in the cartridge
 *    (in order to avoid the 250 saves limitation in BIOS Save Data Manager)
**/
void bakcart_test_fill(void)
{
//#define VMEM_TP_MAXLEN (512*1024)
    Sint32 ret;
    const unsigned char device_id = DEVICE_ID_CART;
    unsigned char* input_buffer  = (unsigned char*)BUP_BUFFER_ADR;
    //unsigned char* temp_buffer = ((unsigned char*)BUP_BUFFER_ADR + VMEM_TP_MAXLEN);
    int i;

    /* Initialize and enable console display. */
//#define VMEM_TB_CONS_Y0 6
//#define VMEM_TB_CONS_HEIGHT (25-VMEM_TB_CONS_Y0)
    cons_enable(VMEM_TB_CONS_Y0, VMEM_TB_CONS_HEIGHT, 0/*pause_enable*/);

    /* Test backup memory access with several input data size patterns :
     *
     * Pattern #0: 
     *  - Constant data size, 512 bytes, 40 times.
     *
     * Pattern #1: 
     *  - Increasing data size, 10 bytes initially.
     *  - 17 bytes added on each time.
     *  - 50 times
     *
     * Pattern #2: 
     *  - Increasing data size, 10 bytes initially.
     *  - 23 bytes added on each time.
     *  - 67 times
     *
     * Pattern #3: 
     *  - Increasing data size, 1 byte initially.
     *  - 1 byte added on each time for first 170 saves, then 297 bytes added each time.
     *  - 500 times
     *
     * Pattern #4: 
     *  - Size of first 30 saves set to 200 KB.
     *  - Remaining saves sized between 2KB and 6KB.
     *  - 170 times
     * 
     * Pattern #5: 
     *  - Half of space remaining in device.
     *  - 10 times
     */
    unsigned long save_cnt_tbl[10] = {40, 50, 67, 500, 170, 10, 0};

    //conio_printf( 2, 4, COLOR_WHITE , "SVCNT:123, PTID:1|123, LEN:12345 KB ");
    conio_printf( 2, 4, COLOR_WHITE , "SVCNT:   , PTID: |   , LEN:      KB ");

    /* Count-up tests from all patterns, for display of progress bar. */
    int pat_id = 0;
    unsigned long save_whole_cnt = 0;
    while(save_cnt_tbl[pat_id] != 0)
    {
        save_whole_cnt += save_cnt_tbl[pat_id];
        pat_id++;
    }


    pat_id = 0;
    unsigned long save_whole_id   = 0; /* Current save in whole list. */
    unsigned long save_write_id   = 0; /* ID of last written save.    */
    unsigned long delete_whole_id = 0; /* ID of next save to delete.  */
    while(save_cnt_tbl[pat_id] != 0)
    {
        /* Show pattern ID on screen. */
        conio_printf(18, 4, COLOR_YELLOW, "%u", pat_id);

        /* Format backup memory before starting current pass. */
        ret = BUP_Format((Uint32)device_id);
        if(ret != 0)
        {
            cons_printf(COLOR_ERROR, "ERROR: format failure !");
            return;
        }

        unsigned long offset = 0;
        unsigned long save_cnt = save_cnt_tbl[pat_id];
        unsigned long save_id;
        for(save_id=0; save_id<save_cnt; save_id++)
        {
            /* The more random the more funny = periodically
             * change test pattern in input buffer.
             */
#define VMEM_PATTERN_REFRESH_PERIOD 256
            if((save_whole_id % VMEM_PATTERN_REFRESH_PERIOD) == 0)
            {
                for(i=0; i<(VMEM_TP_MAXLEN/sizeof(unsigned short)); i++)
                {
                    /* Use different test data each time this test bench is run. */
                    ((unsigned short*)input_buffer)[i] = rand() & 0xFFFF;
                }
                cons_printf(COLOR_BG_FG(COLOR_BLACK, COLOR_YELLOW), "Refresh random data ... %02X %02X %02X %02X", input_buffer[0], input_buffer[1], input_buffer[2], input_buffer[3]);
            }

            /* Show save count and used space on screen. */
            BupStat bupStat;
            memset(&bupStat, 0, sizeof(BupStat));
            BUP_Stat(device_id, 0, &bupStat);
            if((save_id % 32) == 0)
            {
                cons_printf(COLOR_BG_FG(COLOR_BLACK, COLOR_YELLOW), "[%4u %4u]Free %4d KB, %5d blk", delete_whole_id, save_write_id, bupStat.freesize >> 10, bupStat.freeblock);
            }

            conio_printf( 8, 4, COLOR_YELLOW, "%3u", save_write_id - delete_whole_id);
            conio_printf(29, 4, COLOR_YELLOW, "%5u", bupStat.freesize >> 10);

            unsigned long datalen = 123;

            /* Show progress information on screen. */
            conio_printf(20, 4, COLOR_YELLOW, "%3u", save_id);
            conio_drawprogress(
                2*CONIO_CHAR_W, 5*CONIO_CHAR_H, 
                36*CONIO_CHAR_W, 1*CONIO_CHAR_H, 
                save_whole_cnt, save_whole_id);

            if(pat_id == 0)
            {
                datalen = 512;
            }
            else if(pat_id == 1)
            {
                datalen = 10 + 17*save_id;
            }
            else if(pat_id == 2)
            {
                datalen = 10 + 23*save_id;
            }
            else if(pat_id == 3)
            {
                if(save_id < 170)
                {
                    datalen = 1 + save_id;
                }
                else
                {
                    datalen = 170 + (save_id-170) * 297;
                }
            }
            else if(pat_id == 4)
            {
                if(save_id < 30)
                {
                    datalen = 200*1024;
                }
                else
                {
                    datalen = (2*1024) + (rand() % (4*1024));
                }
            }
            else if(pat_id == 5)
            {
                datalen = bupStat.freesize / 2;
                if(datalen > (200*1024))
                {
                    datalen = 200*1024;
                }
                if(datalen < 10)
                {
                    datalen = 10;
                }
            }

            /* Limit the count of the saves recorded in memory cartridge.
             * 
             * (Saves after 250th one aren't displayed in Saturn SDM, apparently
             *  caused by a limitation there; BUP library works fine even after
             *  this limit)
             */
            int write_result = 0;
            if((save_write_id - delete_whole_id) < 210)
            {
                unsigned long test_flag = VMEM_TEST_SILENT_WRITE_FLAG | VMEM_TEST_CRC_COMMENT_FLAG;
                write_result = vmem_access_test(test_flag, device_id, save_write_id, input_buffer+offset, datalen, 0/*delete_save*/, NULL/*temp_buffer*/);

                if(write_result)
                {
                    save_write_id++;
                }
            }

            if(!write_result)
            {
                /* If write failed, it's likely to be a problem of insufficient
                 * space remaining. So let's remove an old save and hope that
                 * it will be possible to write next one.
                 */
                if(!vmem_delete_test(device_id, delete_whole_id, 1/*be_silent*/))
                {
                    /* For some reason, oldest save may not exist.
                     * So don't do anything special in the case delete failed.
                     */
                    //return;
                }

                delete_whole_id++;
            }

            /* Change input data on next backup memory access. */
            if((offset + datalen + 256*1024) >= VMEM_TP_MAXLEN)
            {
                offset = 0;
            }
            else
            {
                offset += datalen;
            }

            save_whole_id++;
        } /* Save loop. */

        /* Jump to next test pattern. */
        pat_id++;
    } /* Pattern loop. */

    cons_printf(COLOR_BG_FG(COLOR_BLACK, COLOR_LIME), "Memory cartridge filled !");
}


/**
 * bakcart_test_verify
 *
 * Verify integrity of save data written on backup memory cartridge device
 * by bakcart_test_fill function.
 *
 * Note : the interest of separating bakcart_test_fill and bakcart_test_verify
 *        in two separate function is to be able to turn off the Saturn after
 *        executing bakcart_test_fill and to verify that streaming of written
 *        save data as well as its load back to backup memory is working
 *        correctly.
**/
void bakcart_test_verify(void)
{
//#define VMEM_TP_MAXLEN (512*1024)
    Sint32 ret;
    const unsigned char device_id = DEVICE_ID_CART;
    unsigned char* temp_buffer = (unsigned char*)BUP_BUFFER_ADR;
    int i;

    /* Initialize and enable console display. */
//#define VMEM_TB_CONS_Y0 6
//#define VMEM_TB_CONS_HEIGHT (25-VMEM_TB_CONS_Y0)
    cons_enable(VMEM_TB_CONS_Y0, VMEM_TB_CONS_HEIGHT, 0/*pause_enable*/);

    /* List save data files in each devices. */
    BupDir* ptb = _bupDir[0];
    ret = BUP_Dir(device_id, (Uint8 *)VMEM_TB_SAVE_PREFIX, BUP_DIR_SIZE, ptb);

    //conio_printf( 2, 4, COLOR_WHITE , "CNT:123, CRC:89ABCDEF, LEN:123456 B ");
    conio_printf( 2, 4, COLOR_WHITE , "CNT:   , CRC:        , LEN:       B ");
    conio_printf( 6, 4, COLOR_YELLOW, "%3d", ret);

    /* Display an error message when save data list could not be retrieved.
     * This typically happens when backup cartridge memory is not inserted
     * correctly, or when bakcart_test_fill function was not called before
     * this one.
     */
    if((ret < 0)   /* Listing error. */
    || (ret == 0)) /* List empty.    */
    {
        conio_printf( 2, 5, COLOR_ERROR, "ERROR: Test save data not found !   ");
        return;
    }

    /* Contents cleanup of all entries. */
    for(i=0; i<ret; i++)
    {
        BupDir* tb = ptb + i;

        /* Add terminating null character to strings. */
        tb->filename[11] = '\0';
        tb->comment [10] = '\0';
    }

    /* Read each test saves and verify their integrity. */
    int saves_cnt = ret;
    for(i=0; i<saves_cnt; i++)
    {
        BupDir* tb = ptb + i;

        /* Retrieve CRC value computed when the save was written.
         * Comment format : "C=12345678", in hexadecimal base.
         */
        unsigned long crc1 = strtoul(((char*)tb->comment)+2, NULL, 16);

        /* Show progress information on screen. */
        conio_printf(29, 4, COLOR_YELLOW, "%6u", tb->datasize);

        conio_drawprogress(
            2*CONIO_CHAR_W, 5*CONIO_CHAR_H, 
            36*CONIO_CHAR_W, 1*CONIO_CHAR_H, 
            saves_cnt, i);

        cons_printf(COLOR_BG_FG(COLOR_BLACK, COLOR_YELLOW), "[%3d]Name:%s, CRC:%08X", i+1, tb->filename, crc1);

        /* Read save data and compute its CRC.
         * In the case backup memory cartridge contents are corrupted, read
         * operation may fail, so show an error message in that case.
         */
        memset(temp_buffer, 0, tb->datasize);
        ret = BUP_Read((Uint32)device_id, tb->filename, (volatile Uint8*)temp_buffer);
        if(ret != 0)
        {
            conio_printf( 2, 5, COLOR_ERROR, "ERROR: Save Data Read Failed !      ");
            return;
        }

        unsigned long crc2 = crc32_calc((const void *)temp_buffer, tb->datasize);
        conio_printf(15, 4, COLOR_YELLOW, "%08X", crc2);

        /* If CRC mismatchs, show an error message and stop testing here. */
        if(crc1 != crc2)
        {
            conio_printf( 2, 5, COLOR_ERROR, "ERROR: Save Data Corrupted !        ");
            return;
        }
    }

    /* Check ended succesfully : display a congratulation message
     * over the progress bar display area.
     */
    conio_printf( 2, 5, COLOR_BG_FG(COLOR_BLACK, COLOR_LIME), "Save Data Integrity Test Passed !   ");
}



/**
 * cartridge_dump_test
 *
 * Some test stuff regarding cartridge dump.
 *
 * Returns zero if need to return to main menu, 1 else.
**/
void bupmem_test_bench(void)
{
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;
    int menu_selected = 1;

    while(1)
    {
        menu_reset_settings(mset);
        menu_set_callback_vblank(mset, bup_anim_starfield);

        menu_set_title(mset, "Backup Memory Test Bench");
        menu_set_pos(mset, -1/*x0*/, -1/*y0*/, 23/*w*/, 0/*h*/, 1/*cols*/);
        menu_set_erase_on_exit(mset, 1);
        menu_set_features(mset, MENU_FEATURES_TEXTCENTER | MENU_FEATURES_CONDENSED_TITLE | MENU_FEATURES_TALL_PROPORTIONAL);

        menu_reset_items(mitems);
        menu_add_item(mitems, "Internal : Vmem Access"      , 0/*tag*/);
        menu_add_item(mitems, "Cartridge : Save Data Fill"  , 1/*tag*/);
        menu_add_item(mitems, "Cartridge : Save Data Verify", 2/*tag*/);

        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);

        if(mset->exit_code == MENU_EXIT_CANCEL)
        {
            return;
        }

        if(menu_selected == 0)
        {
            vmem_test_bench();
        }
        else if(menu_selected == 1)
        {
            bakcart_test_fill();
        }
        else if(menu_selected == 2)
        {
            bakcart_test_verify();
        }

        /* Test ended : turn off debug console and clear screen. */
        wait_for_start(NULL);
        cons_disable();
        clear_screen();
    }
}



/**
 * cartridge_dump_test
 *
 * Some test stuff regarding cartridge dump.
 *
 * Returns zero if need to return to main menu, 1 else.
**/
int cartridge_dump_test(void)
{
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;
    int menu_selected = 0;

    int line = 15;
    int half_dump = 0;

    while(1)
    {
        conio_printf( 2, line+0, COLOR_YELLOW, "* Warning : internal backup memory *");
        conio_printf( 2, line+1, COLOR_YELLOW, "* will be formatted !              *");

        menu_reset_settings(mset);
        menu_set_callback_vblank(mset, bup_anim_starfield);

        menu_set_title(mset, "Cartridge Dump Test");
        menu_set_help(mset, "A/C: Confirm, B: Normal Dump Menu");
        menu_set_pos(mset, -1/*x0*/, 4*CONIO_CHAR_H/*y0*/, 30/*w*/, 0/*h*/, 1/*cols*/);
        menu_set_erase_on_exit(mset, 1);
        menu_set_features(mset, MENU_FEATURES_TEXTCENTER);

        menu_reset_items(mitems);
        menu_add_item(mitems, " Test1 (memcpy)        ", 0/*tag*/);
        menu_add_item(mitems, " Test2 (16bit copy)    ", 1/*tag*/);
        menu_add_item(mitems, " Test3 (via cache)     ", 2/*tag*/);
        if(!half_dump)
        {
            menu_add_item(mitems, " Enable Half Dump      ", 8/*tag*/);
        }
        menu_add_item(mitems, " Normal Dump Menu      ", 9/*tag*/);

        menu_selected = 2;
        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);

        clear_screen();

        if(mset->exit_code == MENU_EXIT_CANCEL)
        {
            /* Go to main menu. */
            clear_screen();
            return 0;
        }

        if(menu_selected == 8)
        {
            half_dump = 1;
        }
        else
        {
            break;
        }
    }

    if(menu_selected == 9)
    {
        /* Go to normal dump menu. */
        clear_screen();
        return 1;
    }

    memset(_extract_buff, 0, 256*1024); /* Max 256KB */
    unsigned char* cartrom_ptr = (unsigned char*)0x22000000;
    unsigned char* copy_buff = _extract_buff;
    unsigned char* compress_buff = _extract_buff + (128*1024);
    unsigned long copy_size = 32*1024;
    unsigned long i;

    if(half_dump)
    {
        copy_size = copy_size / 2;
    }

    conio_printf( 2, line++, COLOR_WHITE, "Copying ROM ...");

    if(menu_selected == 0)
    {
        memcpy(copy_buff, cartrom_ptr, copy_size);
    }
    else if((menu_selected == 1) || (menu_selected == 2))
    {
        if(menu_selected == 2)
        {
            cartrom_ptr = (unsigned char*)0x02000000;
        }

        for(i=0; i<copy_size; i+=sizeof(unsigned short))
        {
            *((unsigned short*)(copy_buff+i)) = *((unsigned short*)(cartrom_ptr+i));
        }
    }

    /* Compress everything so that it should fit into BRAM. */
    conio_printf( 2, line++, COLOR_WHITE, "Compressing (%u bytes) ...", copy_size);
    unsigned long comp_len = comp_exec(copy_buff, copy_size, compress_buff);
    conio_printf( 2, line++, COLOR_WHITE, "Compress done (%u bytes) ...", comp_len);

    /* Format BRAM. */
    Sint32 ret;
    unsigned char device_id = DEVICE_ID_BRAM;
    conio_printf( 2, line++, COLOR_WHITE, "BUP_Format ...");
    ret = BUP_Format((Uint32)device_id);
    conio_printf( 2, line++, COLOR_WHITE, "BUP_Format = %d", ret);


    /* Write to BRAM. */
    BupDir bupDirData;
    BupDir* tb = &bupDirData;
    char filename[16];
    sprintf(filename, "DUMPTEST__%u", menu_selected+1);

    memset((void*)tb, 0, sizeof(BupDir));
    strcpy((char*)(tb->filename), filename);
    sprintf((char*)(tb->comment), "%5d Byte", (int)comp_len);
    tb->language = BUP_ENGLISH;
    tb->date = bup_get_saturn_date();
    tb->datasize = comp_len;

    /*
     * Return codes memo :
     *
     * #define	BUP_NON			(1)
     * #define	BUP_UNFORMAT		(2)
     * #define	BUP_WRITE_PROTECT	(3)
     * #define	BUP_NOT_ENOUGH_MEMORY	(4)
     * #define	BUP_NOT_FOUND		(5)
     * #define	BUP_FOUND		(6)
     * #define	BUP_NO_MATCH		(7)
     * #define	BUP_BROKEN		(8)
     */

    conio_printf( 2, line++, COLOR_WHITE, "BUP_Write(%s, 0) ...", filename);
    ret = BUP_Write((Uint32)device_id, tb, (volatile Uint8*)compress_buff, 0/* overwrite check */);
    conio_printf( 2, line++, COLOR_WHITE, "BUP_Write(%s, 1) = %d", filename, ret);

    if(ret != 0)
    {
        conio_printf( 2, line++, COLOR_ERROR, "Dump data write error !");
    }
    else
    {
        conio_printf( 2, line++, COLOR_WHITE, "Dump data write done !");
    }

    wait_for_start(NULL);
    clear_screen();

    return 0;
}



/**
 * buplib_stack_test
 *
 * Test how far BUP library uses stack.
**/
BupDir _bupDirStackTest;
void buplib_stack_test(void)
{
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;
    int menu_selected = 1;

    int bup_write_test = 1;
    int bup_read_test  = 1;
    int bup_dir_test   = 0;

    while(1)
    {
        conio_printf( 2, 23, COLOR_YELLOW, "* Warning : all backup memory      *");
        conio_printf( 2, 24, COLOR_YELLOW, "* contents will be formatted !     *");

        menu_reset_settings(mset);
        menu_set_callback_vblank(mset, bup_anim_starfield);

        menu_set_title(mset, "BUP Library Stack Test");
        menu_set_help(mset, "A/C: Confirm, B: Normal Dump Menu");
        menu_set_pos(mset, 2*CONIO_CHAR_W/*x0*/, 4*CONIO_CHAR_H/*y0*/, 28/*w*/, 0/*h*/, 1/*cols*/);
        menu_set_erase_on_exit(mset, 1);
        menu_set_features(mset, MENU_FEATURES_TEXTCENTER);

        menu_reset_items(mitems);
        menu_add_item(mitems, " Test Internal BRAM ", 0/*tag*/);
        menu_add_item(mitems, " Test Cartridge BRAM", 1/*tag*/);
        menu_add_item(mitems, " BUP_Write Test     ", 2/*tag*/);
        menu_add_item(mitems, " BUP_Read Test      ", 3/*tag*/);
        menu_add_item(mitems, " BUP_Dir Test       ", 4/*tag*/);

        /* Show test enable/disable status for each BUP entry points. */
        conio_font_printf(FONT_DEFAULT, FONT_CODEPAGE_JAPANESE, (34)*CONIO_CHAR_W, (4*CONIO_CHAR_H+3 + (3*MENU_CHAR_H)), COLOR_WHITE, "%s", (bup_write_test ? "ON " : "OFF"));
        conio_font_printf(FONT_DEFAULT, FONT_CODEPAGE_JAPANESE, (34)*CONIO_CHAR_W, (4*CONIO_CHAR_H+3 + (4*MENU_CHAR_H)), COLOR_WHITE, "%s", (bup_read_test  ? "ON " : "OFF"));
        conio_font_printf(FONT_DEFAULT, FONT_CODEPAGE_JAPANESE, (34)*CONIO_CHAR_W, (4*CONIO_CHAR_H+3 + (5*MENU_CHAR_H)), COLOR_WHITE, "%s", (bup_dir_test   ? "ON " : "OFF"));


        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);

        clear_screen();
        int line = 15;

        if(mset->exit_code == MENU_EXIT_CANCEL)
        {
            /* Go to main menu. */
            clear_screen();
            return;
        }

        if(menu_selected == 2)
        {
            bup_write_test = 1-bup_write_test;
        }
        else if(menu_selected == 3)
        {
            bup_read_test = 1-bup_read_test;
        }
        else if(menu_selected == 4)
        {
            bup_dir_test = 1-bup_dir_test;
        }
        else if((menu_selected == 0) || (menu_selected == 1))
        {
            int use_cart = (menu_selected == 0 ? 0 : 1);
            int i;

            /* Get stack pointer, and sanitize it. */
            unsigned long stack_ptr;
            asm("mov r15,%0": "=r"(stack_ptr));
            stack_ptr = stack_ptr & 0x0FFFFFFC;

            /* Clear stack with "magic" (something else than 00 or FF) value. */
#define STACK_MAX_DEPTH (2048/sizeof(unsigned long))
//#define STACK_INIT_VAL(_ID_)  0xA5A55A5A
#define STACK_INIT_VAL(_ID_)  (0xA5A50000|(_ID_))

            for(i=(STACK_MAX_DEPTH-1); i>32; i--)
            {
                *((unsigned long*)(stack_ptr - i*sizeof(unsigned long))) = STACK_INIT_VAL(i);
            }

            /* Internals to play with BUP library */
            Sint32 ret = 0;
            unsigned char device_id = (use_cart ? DEVICE_ID_CART : DEVICE_ID_BRAM);
            memset(_bupConf, 0, sizeof(BupConfig)*BUP_DEVICE_CNT);
            memset(_bupLibrary, 0, sizeof(unsigned long)*4096);
            memset(_bupRamWork, 0, sizeof(unsigned long)*2048);

            /* Initialize dummy backup data. */
            unsigned char* data_buff = _extract_buff;
            unsigned long data_len = (use_cart ? 256*1024 : 4*1024);
            for(i=0; i<data_len; i++)
            {
                data_buff[i] = i & 0xFF;
            }

            /* Initialize dummy backup header. */
            BupDir* tb = &_bupDirStackTest;

            memset((void*)tb, 0, sizeof(BupDir));
            sprintf((char*)(tb->filename), "STACKTST000");
            sprintf((char*)(tb->comment), "1234567890");
            tb->language = BUP_ENGLISH;
            tb->date = 0x12345678;
            tb->datasize = data_len;


            /* Initialize BUP library : common to all tests. */
            BUP_Init((volatile unsigned long *)_bupLibrary, _bupRamWork, _bupConf);

            if(bup_write_test)
            {
                ret = BUP_Write((Uint32)device_id, tb, (volatile Uint8*)data_buff, 0/* overwrite check */);
            }

            if(bup_write_test)
            {
            }

            if(bup_dir_test)
            {
                ret = BUP_Dir((Uint32)device_id, (Uint8 *)"", BUP_DIR_SIZE, _bupDir[0]);
            }

            /* Measure how far stack was modified. */
            unsigned long stack_usage = 0;
            for(i=(STACK_MAX_DEPTH-1); i>0; i--)
            {
                if(*((unsigned long*)(stack_ptr - i*sizeof(unsigned long))) != STACK_INIT_VAL(i))
                {
                    stack_usage = i*sizeof(unsigned long);
                    break;
                }
            }


            /*
             * Return codes memo :
             *
             * #define	BUP_NON			(1)
             * #define	BUP_UNFORMAT		(2)
             * #define	BUP_WRITE_PROTECT	(3)
             * #define	BUP_NOT_ENOUGH_MEMORY	(4)
             * #define	BUP_NOT_FOUND		(5)
             * #define	BUP_FOUND		(6)
             * #define	BUP_NO_MATCH		(7)
             * #define	BUP_BROKEN		(8)
             */
            conio_printf( 2, line++, COLOR_WHITE, "use_cart:%d, len:%u KB", use_cart, data_len >> 10);
            conio_printf( 2, line++, COLOR_WHITE, "RET : %d", ret);
            conio_printf( 2, line++, COLOR_WHITE, "Stack Pointer : 0x%08X"  , stack_ptr);
            conio_printf( 2, line++, COLOR_WHITE, "Stack Usage   : %u Bytes", stack_usage);
        }
    }
}




/**
 * smpctest_bgnd_vblank_clbk
 *
 * Internal function for smpc_pad_test.
**/
extern unsigned char _oreg_buff[32*4];
extern pad_t _pad;
void smpctest_bgnd_vblank_clbk(void)
{
    /* Execute default V-Blank handler. */
    bup_anim_starfield();

    /* Show pad status. */
    pad_t* p = &_pad;
    int i;
    int row = 9;

    /* First, show raw values from SMPC. */
    conio_printf(5, row++, COLOR_WHITE, "OREG:");
    for(i=0; i<32; i++)
    {
#define OREG_DISP_ROWCOUNT 8

        unsigned short color = COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK);
        conio_printf(5 + (i % OREG_DISP_ROWCOUNT) * 3, row, color, "%02X", _oreg_buff[i]);

        if(((i+1) % OREG_DISP_ROWCOUNT) == 0)
        {
            row++;
        }
    }


    int pad_id = 0;
    /* Number of peripherals connected. */
    conio_printf( 5, row+0, COLOR_WHITE, "per_count:%3u", p->per_count);

    for(i=0; i<2; i++)
    {
        int stt_col = (i == 0 ? 0 : 18);

        /* Pad ID. */
        conio_printf(stt_col+ 5, row+1, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "%s", (i == 0 ? " PAD #1     " : " PAD #2     "));

        /* Up */
        conio_printf(stt_col+ 5, row+2, COLOR_WHITE, " %c", 
                    (p->new[pad_id+i] & PAD_UP ? 'U' : '.'));
        /* Left, Right */
        conio_printf(stt_col+ 5, row+3, COLOR_WHITE, "%c %c", 
                    (p->new[pad_id+i] & PAD_LEFT  ? 'L' : '.'), 
                    (p->new[pad_id+i] & PAD_RIGHT ? 'R' : '.'));
        /* Down */
        conio_printf(stt_col+ 5, row+4, COLOR_WHITE, " %c", 
                    (p->new[pad_id+i] & PAD_DOWN ? 'D' : '.'));

        /* L,R */
        conio_printf(stt_col+12, row+2, COLOR_WHITE, "%c   %c", 
                    (p->new[pad_id+i] & PAD_LBUTTON ? 'L' : '.'), 
                    (p->new[pad_id+i] & PAD_RBUTTON ? 'R' : '.'));
        /* X,Y,Z */
        conio_printf(stt_col+12, row+3, COLOR_WHITE, "%c %c %c", 
                    (p->new[pad_id+i] & PAD_X ? 'X' : '.'), 
                    (p->new[pad_id+i] & PAD_Y ? 'Y' : '.'), 
                    (p->new[pad_id+i] & PAD_Z ? 'Z' : '.'));
        /* A,B,C */
        conio_printf(stt_col+12, row+4, COLOR_WHITE, "%c %c %c", 
                    (p->new[pad_id+i] & PAD_A ? 'A' : '.'), 
                    (p->new[pad_id+i] & PAD_B ? 'B' : '.'), 
                    (p->new[pad_id+i] & PAD_C ? 'C' : '.'));

        /* Start */
        conio_printf(stt_col+10, row+5, COLOR_WHITE, "%s", (p->new[pad_id+i] & PAD_START ? "START" : "     "));
    }
    row += 6;

    /* Raw values after SMPC status decoding. */
    for(i=0; i<6; i+=3)
    {
        conio_printf( 5, row, COLOR_WHITE, "p->new[%d]: %04X %04X %04X", i, p->new[i+0], p->new[i+1], p->new[i+2]);
        row++;
    }
    conio_printf( 5, row++, COLOR_WHITE, "p->old   = %04X %04X %04X", p->old  [0], p->old  [1], p->old  [2]);
    conio_printf( 5, row++, COLOR_WHITE, "p->delta = %04X %04X %04X", p->delta[0], p->delta[1], p->delta[2]);
    conio_printf( 5, row++, COLOR_WHITE, "cnt:%02X %02X %02X %02X %02X %02X %02X", 
                    p->repeat_cnt[0][0], 
                    p->repeat_cnt[0][1], 
                    p->repeat_cnt[0][2], 
                    p->repeat_cnt[0][3], 
                    p->repeat_cnt[0][4], 
                    p->repeat_cnt[0][5], 
                    p->repeat_cnt[0][6]);
    conio_printf( 5, row++, COLOR_WHITE, "    %02X %02X %02X %02X %02X %02X", 
                    p->repeat_cnt[0][ 7], 
                    p->repeat_cnt[0][ 8], 
                    p->repeat_cnt[0][ 9], 
                    p->repeat_cnt[0][10], 
                    p->repeat_cnt[0][11], 
                    p->repeat_cnt[0][12]);
}

/**
 * smpc_pad_test
 *
 * Show SMPC internals during pad status acquisition.
**/
void smpc_pad_test(void)
{
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;

    int menu_selected = 0;

    menu_reset_settings(mset);

    /* Greyout logo in order to show debug text.*/
    menu_set_logo_patterns(mset, LOGOPAT_GREYOUT, LOGOPAT_GREYOUT);

    menu_set_callback_vblank(mset, smpctest_bgnd_vblank_clbk);

    //menu_set_help(mset, "A/C: Confirm, B: Return");

    menu_set_title(mset, "SMPC Test Dummy Menu");

    menu_set_pos(mset, -1/*x0*/, 4*CONIO_CHAR_H/*y0*/, 26/*w*/, 0/*h*/, 2/*cols*/);
    menu_set_erase_on_exit(mset, 1);
    menu_set_features(mset, MENU_FEATURES_TEXTCENTER);

    menu_reset_items(mitems);
    menu_add_item(mitems, "Test 1", 0/*tag*/);
    menu_add_item(mitems, "Test 2", 1/*tag*/);
    menu_add_item(mitems, "Test 3", 2/*tag*/);
    menu_add_item(mitems, "Test 4", 3/*tag*/);

    clear_screen();
    while(1)
    {
        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);
    }
}



/*
 *  Format          void BUP_GetDate(Uint32 pdate,BupDate *date)
 *  Input           pdate : data and time data of directory information
 *                  date : date and time table
 *  Output          none
 *  Function value  none
 *  Function        Expands the date and time data in the directory information table.
 */
void my_bup_getdate(Uint32 date, BupDate *tb)
{
    unsigned long div;

    /* Set minute count. */
    tb->min = (unsigned char)(date % 60);

    /* Set hour. */
    tb->time = (unsigned char)((date % (60*24)) / 60);

    /* Compute days count. */
    div = date / (60*24);

    /* Set of week. */
    if (div > 0xAB71)
    {
        tb->week = (unsigned char)((div + 1) % 7);
    }
    else
    {
        tb->week = (unsigned char)((div + 2) % 7);
    }

    /* To process leap year, simply consider a pack of 4 years whose first one
     * is a multiple of 4, and loop up to 48 months until getting remaining
     * days count fitting into one month.
     *
     * It's a bit kind of naive (not to say dumb) implementation, but it works, 
     * and as it's not the kind of routine that require heavy optimization
     * there's no plan to make this algorithm smarter.
     */
    unsigned long year_base   = div / ((365*4) + 1); year_base = year_base * 4;
    unsigned long days_remain = div % ((365*4) + 1);
    const char days_count[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

    unsigned char month = 0;
    int i;
    for(i=0; i<(4*12); i++)
    {
        unsigned char days_per_month = days_count[i % 12];
        if(i == 1)
        {
            days_per_month++;
        }

        if(days_remain < days_per_month)
        {
            break;
        }

        days_remain -= days_per_month;
        month++;

        if((i % 12) == 11)
        {
            month = 0;
            year_base++;
        }
    }

    tb->month = month + 1;
    tb->day   = days_remain + 1;
    tb->year  = year_base;


    /* Code below is here to reproduce the same bug as in Saturn BIOS, 
     * so please disable it if you prefer a valid date rather than a
     * completely equivalent re-implementation.
     * 
     * Description : 1st January following a leap year is incorrectly
     *               returned as December 32nd of this leap year.
     * 
     * Examples :
     *  >Error2 #  1, BIO:1980/12/32 00:42 4, B:00080AEA
     *  >           , VMM:1981/01/01 00:42 4
     *  >           , ORG:1981/01/01 00:42
     *  >Error2 #  2, BIO:1980/12/32 07:42 4, B:00080C8E
     *  >           , VMM:1981/01/01 07:42 4
     *  >           , ORG:1981/01/01 07:42
     *  >Error2 #  5, BIO:1984/12/32 00:42 2, B:0028250A
     *  >           , VMM:1985/01/01 00:42 2
     *  >           , ORG:1985/01/01 00:42
     */
#if 1
    if((tb->month      == 1)
    && (tb->day        == 1)
    && ((tb->year % 4) == 1))
    {
        tb->month = 12;
        tb->day   = 32;
        tb->year--;
    }
#endif
}


/*
 *  Format          Uint32 BUP_SetDate(BupDate *date)
 *  Input           date : date and time table
 *  Output          none
 *  Function value  Data in date and time data form in the directory information table.
 *  Function        Compresses the date and time data in the directory information table.
 */
Uint32 my_bup_setdate(BupDate *tb)
{
    /* Table of elapsed days per month. */
    const unsigned short monthtbl[11] =
    {
        31, 
        31+28, 
        31+28+31, 
        31+28+31+30, 
        31+28+31+30+31, 
        31+28+31+30+31+30, 
        31+28+31+30+31+30+31, 
        31+28+31+30+31+30+31+31, 
        31+28+31+30+31+30+31+31+30, 
        31+28+31+30+31+30+31+31+30+31, 
        31+28+31+30+31+30+31+31+30+31+30
    };
    unsigned long date;
    unsigned char data;
    unsigned long remainder;


    /* Easter Egg when specified time is set to invalid null values
     * 
     * Technical details on SegaXtreme forums :
     *  https://segaxtreme.net/threads/backup-memory-structure.16803/
     *
     * antime   : If you take the 1980/0/0 value and go backwards from
     *            1980/1/1 you get 1963/10/8. I wonder if that's an
     *            easter egg - the programmer's birthday or something similar. 
     * TascoDLX : The value in question, 0x008246A0, corresponds to
     *            1996/3/26 0:00, which pretty much coincides with the
     *            passing of Comet Hyakutake.
     *            As far as easter eggs go, that'd be my guess. 
     * antime   : The comet wasn't discovered until January 1996.
     *            That'd be hell of an easter egg...
     * 
     * Note : in this re-implementation, the value before adding this
     *        easter egg was : t:0x026CECE0 -> 2057/05/15 00:00
     *        Probably something caused by random value read outside range, 
     *        or indicating the passing of another new comet ?!
     */
    if((tb->year  == 0)
    && (tb->month == 0)
    && (tb->day   == 0)
    && (tb->time  == 0)
    && (tb->min   == 0))
    {
        return 0x008246A0;
    }

    /* Add year to result. */
    data = tb->year;
    date = (data / 4) * 0x5B5; // 0x5B5 = 365.25 * 4
    remainder = data % 4;
    if(remainder)
    {
        date += (remainder * 0x16D) + 1; // 0x16D = 365
    }

    /* Leap year fix.
     * Code from Yabause HLE BIOS seems broken regarding leap years support.
     *
     * Rather than making a "clean" fix, and also because I'm not smart enough
     * to understand the "365.25 * 4" code above, date is adjusted in cases
     * causing problems.
     * 
     * Additionally, I don't want to spend days in optimizing that : writing
     * accurate date manipulation routines is some kind of art that may chew
     * a lot of free time that would be better being dedicated in more
     * interesting projects.
     * 
     * Fix is verified under test bench implemented in Save Data Manager's
     * extra menu which compares result between BIOS and this custom BUP_SetDate
     * functions, so that it should behave fine in any possible case until 2199.
     */
    unsigned short year = 1980 + tb->year;
    int leap_year;
    if((year % 4) != 0)
    {
        leap_year = 0;
    }
    else if((year % 100) != 0)
    {
        leap_year = 1;
    }
    else if((year % 400) != 0)
    {
        leap_year = 0;
    }
    else
    {
        leap_year = 1;
    }

    date--;
    if((leap_year) && (tb->month == 2))
    {
        date--;
    }
    if((year > 2000) && ((year % 100) == 0) && (tb->month == 2))
    {
        date--;
    }

    /* Add month to result. */
    data = tb->month;
    if(data != 1 && data < 13)
    {
        date += monthtbl[data - 2];
        if(date > 2 && remainder == 0)
        {
            date++;
        }
    }

    /* Add day to result. */
    date += tb->day;
    date *= 0x5A0;

    /* Add hour to result. */
    date += (tb->time * 0x3C);

    /* Add minute to result. */
    date += tb->min;

    return date;
}


/**
 * bup_time_test
 *
 * Compare behavior of time conversion routines between
 * BUP library and the ones re-implemented here.
 * 
 * From a time structure, it computes their time stamps with
 * both BUP library and re-implementation and verify they match.
 * Then, it uses this time stamp to get back time informations
 * with both BUP library and re-implementation and verify they match.
 * 
 * All minutes between 1980 January 1st and end of December 2199 are
 * tested, so please consider this feature as some kind of retro
 * screen saver, or when you want your Saturn's CPUs to heat your room etc.
**/
void bup_time_test(void)
{
    unsigned long saturn_time1 = 0;
    unsigned long saturn_time2 = 0;
    BupDate sat_date_body1 = { 0 };
    BupDate* sat_date1 = &sat_date_body1;
    BupDate sat_date_body2 = { 0 };
    BupDate* sat_date2 = &sat_date_body2;
    BupDate sat_date_body3 = { 0 };
    BupDate* sat_date3 = &sat_date_body3;

//typedef struct BupDate {
//	Uint8	year;		/* Year - 1980 */
//	Uint8	month;		/* Month (1~12) */
//	Uint8	day;		/* Day (1~31) */
//	Uint8	time;		/* Hour (0~23) */
//	Uint8	min;		/* Minute (0~59) */
//	Uint8	week;		/* Weekday: (Sunday:0 - Saturday:6) */
//}

    /* ------------------------------------------ */
    saturn_time1 = 0;
    memset(sat_date1, 0, sizeof(BupDate));
#if 0
    /* Test BIOS behavior regarding zero time stamp. */
    saturn_time1 = BUP_SetDate(sat_date1);
    BUP_GetDate(saturn_time1, sat_date1);
#else
    /* Verify re-implementation of zero time stamp. */
    saturn_time1 = my_bup_setdate(sat_date1);
    my_bup_getdate(saturn_time1, sat_date1);
#endif

    scd_logout("ZeroTime Test -> t:0x%08X -> %4u/%02u/%02u %02u:%02u", 
        saturn_time1, 
        1980 + sat_date1->year, 
        sat_date1->month, 
        sat_date1->day, 
        sat_date1->time, 
        sat_date1->min);

    //wait_for_start(NULL);
    /* ------------------------------------------ */


    unsigned long count = 0;
    unsigned long errc = 0;

    int col1 =  7;
    conio_printf( 2, col1-3, COLOR_YELLOW, " COUNT:               ERR: NONE     ");
    conio_printf( 2, col1-2, COLOR_YELLOW, " YYYYMMDD HH:MM   | BUP_T  | VMEM_T ");
    conio_printf( 2, col1-1, COLOR_YELLOW, "------------------+--------+--------");
    conio_printf( 2, col1-0, COLOR_YELLOW, "                  |        |        ");

    int col2 = 14;
    conio_printf( 2, col2-2, COLOR_YELLOW, " YYYYMMDD HH:MM W | YYYYMMDD HH:MM W");
    conio_printf( 2, col2-1, COLOR_YELLOW, "------------------+-----------------");
    conio_printf( 2, col2-0, COLOR_YELLOW, "                  |                 ");

    unsigned char tm_year = 40;
    unsigned char tm_mon  = 1;
    unsigned char tm_mday = 28;
    unsigned char tm_hour = 18;
    unsigned char tm_min = 42;
    unsigned char tm_wday = 2;

    const int days_count[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    for(tm_year=0; tm_year<=219; tm_year+=1)
    {
        unsigned short year = 1980 + tm_year;
        int leap_year;
        if((year % 4) != 0)
        {
            leap_year = 0;
        }
        else if((year % 100) != 0)
        {
            leap_year = 1;
        }
        else if((year % 400) != 0)
        {
            leap_year = 0;
        }
        else
        {
            leap_year = 1;
        }

        for(tm_mon=1; tm_mon<=12; tm_mon+=1)
        {
            int days_in_month = days_count[tm_mon-1];
            if((leap_year) && (tm_mon == 2))
            {
                days_in_month++;
            }

            for(tm_mday=1; tm_mday<=days_in_month; tm_mday+=1)
            for(tm_hour=0; tm_hour<=23; tm_hour+=1)
            for(tm_min=0; tm_min<=59; tm_min+=1)
            //for(tm_wday=0; tm_wday<=6; tm_wday++)
            {
                count++;

                sat_date1->year  = tm_year;     /* Year - 1980 */
                sat_date1->month = tm_mon;      /* Month (1~12) */
                sat_date1->day   = tm_mday;     /* Day (1~31) */
                sat_date1->time  = tm_hour;     /* Hour (0~23) */
                sat_date1->min   = tm_min;      /* Minute (0~59) */
                sat_date1->week  = tm_wday;     /* Weekday: (Sunday:0 - Saturday:6) */

                saturn_time1 = BUP_SetDate(sat_date1);
                saturn_time2 = my_bup_setdate(sat_date1);

                int err1 = 0;
                if(saturn_time2 != saturn_time1)
                {
                    err1 = 1;
                }

                int err2 = 0;
                if(!err1)
                {
                    BUP_GetDate   (saturn_time1, sat_date2);
                    my_bup_getdate(saturn_time1, sat_date3);

                    if((sat_date2->year  != sat_date3->year )
                    || (sat_date2->month != sat_date3->month)
                    || (sat_date2->day   != sat_date3->day  )
                    || (sat_date2->time  != sat_date3->time )
                    || (sat_date2->min   != sat_date3->min  )
                    || (sat_date1->week  != sat_date1->week ))
                    {
                        err2 = 1;
                    }
                }

                if(((count & 0x000003FF) == 0x00000000)
                || (err1)
                || (err2))
                {
                    conio_printf(10, 4, COLOR_WHITE, "%9u", count);

                    conio_printf( 3, col1, COLOR_WHITE, 
                        "%4u%02u%02u %02u:%02u   ", 
                        1980 + sat_date1->year, 
                        sat_date1->month, 
                        sat_date1->day, 
                        sat_date1->time, 
                        sat_date1->min);
                    conio_printf(21, col1, COLOR_WHITE, "%08X", saturn_time1);
                    conio_printf(30, col1, COLOR_WHITE, "%08X", saturn_time2);

                    conio_printf( 3, col2, COLOR_WHITE, 
                        "%4u%02u%02u %02u:%02u %u", 
                        1980 + sat_date2->year, 
                        sat_date2->month, 
                        sat_date2->day, 
                        sat_date2->time, 
                        sat_date2->min, 
                        sat_date2->week);
                    conio_printf(22, col2, COLOR_WHITE, 
                        "%4u%02u%02u %02u:%02u %u", 
                        1980 + sat_date3->year, 
                        sat_date3->month, 
                        sat_date3->day, 
                        sat_date3->time, 
                        sat_date3->min, 
                        sat_date3->week);

                    if((err1)
                    || (err2))
                    {
                        errc++;
                        unsigned long p = (100 * errc) / count;
                        conio_printf(27, 4, COLOR_WHITE, "%4u %3u%%", errc, p);

                        /* Emergency stop. */
                        if(errc > 500)
                        {
                            wait_for_start(NULL);
                            clear_screen();
                        }
                    }
                }

                if(err1)
                {
                    if(errc < 50)
                    {
                        scd_logout("Error1 #%2u, t:%4u/%02u/%02u %02u:%02u %u, B:%08X, V:%08X, D:%08X|%08X", 
                            errc, 
                            1980 + sat_date1->year, 
                            sat_date1->month, 
                            sat_date1->day, 
                            sat_date1->time, 
                            sat_date1->min, 
                            sat_date1->week, 
                            saturn_time1, 
                            saturn_time2, 
                            saturn_time1 - saturn_time2, 
                            saturn_time2 - saturn_time1);
                    }

                    if(col1 < 11)
                    {
                        col1++;
                        conio_printf( 2, col1, COLOR_YELLOW, "                  |        |        ");
                    }
                }

                if(err2)
                {
                    if(errc < 50)
                    {
                        scd_logout("%s #%3u, BIO:%4u/%02u/%02u %02u:%02u %u, B:%08X", 
                            err2 ? "Error2" : "      ", 
                            errc, 
                            1980 + sat_date2->year, 
                            sat_date2->month, 
                            sat_date2->day, 
                            sat_date2->time, 
                            sat_date2->min, 
                            sat_date2->week, 
                            saturn_time1);
                        scd_logout("           , VMM:%4u/%02u/%02u %02u:%02u %u", 
                            1980 + sat_date3->year, 
                            sat_date3->month, 
                            sat_date3->day, 
                            sat_date3->time, 
                            sat_date3->min, 
                            sat_date3->week);
                        scd_logout("           , ORG:%4u/%02u/%02u %02u:%02u", 
                            1980 + sat_date1->year, 
                            sat_date1->month, 
                            sat_date1->day, 
                            sat_date1->time, 
                            sat_date1->min);
                    }

                    if(col2 < 23)
                    {
                        col2++;
                        conio_printf( 2, col2, COLOR_YELLOW, "                  |                 ");
                    }
                }
            }
        } // Month loop
    } // Year loop

    wait_for_start(NULL);
    clear_screen();
}



/**
 * igr_handler_dump
 *
 * Dump in-game reset handler code to SD card.
**/
void igr_handler_dump(void)
{
    char file_path[SC_PATHNAME_MAXLEN];
    unsigned char dev_id = SC_FILE_SDCARD;

    int col = 5;

    /* Init SatCom. */
    conio_printf( 2, col++, COLOR_YELLOW, "Initializing SatCom ...");
    bup_satcom_init();

    /* Dump to PC when testing on Yabause.
     * That's easier for me to verify the results.
     */
    int yabause_debug = (((REG_CPLD_55 == 0x55) && (REG_CART_BETA_ID & 0x80)) ? 1 : 0);
    if(yabause_debug)
    {
        dev_id = SC_FILE_PC;
    }

    unsigned long* igr_loc_ptr = (unsigned long*)0x0600026C;
    unsigned long  igr_loc = *igr_loc_ptr;

    unsigned char* dump_address = (unsigned char*)igr_loc;
    unsigned long  dump_length  = 2048;

    conio_printf( 2, col++, COLOR_YELLOW, "Dump IGR handler to %s ...", (dev_id == SC_FILE_SDCARD ? "SD card" : "PC"));
    sprintf(file_path, "/IGR_DUMP.BIN");
    scf_write((void*)dump_address, dump_length, dev_id, file_path);

    conio_printf( 2, col++, COLOR_YELLOW, "Dump logs ...");
    char ip_buff[128+1];
    memcpy(ip_buff, (void*)0x06002010, sizeof(ip_buff)-1);
    int i;
    for(i=0; i<(sizeof(ip_buff)-1); i++)
    {
        ip_buff[i] = char2pchar(ip_buff[i]);
    }
    ip_buff[sizeof(ip_buff)-1] = '\0';

    char log_buff[128+sizeof(ip_buff)];
    sprintf(log_buff, "IGR location: 0x%08X\r\nIP header: %s", (unsigned int)igr_loc, ip_buff);
    sprintf(file_path, "/IGR_DUMP.TXT");
    scf_write((void*)log_buff, strlen(log_buff), dev_id, file_path);

    conio_printf( 2, col++, COLOR_YELLOW, "Dump done.");

    wait_for_start(NULL);
    clear_screen();
}



// Extra bit of code to decompress data read from save data, 
// and write back to PC-Link
// This was initially put in bup_import_single.c source, just
// after reading save data specified by user.
#if 0
{
    unsigned char* decomp_buff = _extract_buff + (128*1024);
    unsigned long decomp_len;
    decomp_len = decomp_exec(_extract_buff, tb->datasize, decomp_buff);
    scf_write(decomp_buff, decomp_len, SC_FILE_PC, "/TAYST.BIN");
    char tmp[128];
    sprintf(tmp, "Write Ended ! (%u bytes)", (int)decomp_len);
    wait_for_start(tmp);
}
#endif




void extra_menu(void)
{
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;
    int menu_selected = 4;

    /* Small tweak in order to continue receiving logs from vmem.
     * Comment-out the line below if you prefer to get logs from Save Data Manager.
     */
#define EXTRA_RCV_VMEM_LOGS
#ifdef EXTRA_RCV_VMEM_LOGS
    sc_global_t global_tmp;
    sc_global_t* gl = (sc_global_t*)SC_GLOBAL_DATA_ADR;
    memcpy(&global_tmp, gl, sizeof(sc_global_t));
#endif

    /* Init SatCom. */
    bup_satcom_init();

#ifdef EXTRA_RCV_VMEM_LOGS
    memcpy(gl, &global_tmp, sizeof(sc_global_t));
#endif


    /* (Re-)load logo stuff.
     * If custom logo couldn't be loaded (SD card not available, 
     * custom logo file not set, etc), then default logo is loaded instead.
     */
    dbg_print("[Extra]Initialize logo ...");
    logo_load(_logo_load_params+LOGO_CUSTOM_LOAD_PARAMS);

    dbg_print("[Extra]SatCom init end");

    while(1)
    {
        menu_reset_settings(mset);
        menu_set_callback_vblank(mset, bup_anim_starfield);

        menu_set_title(mset, "Extra Menu");
        menu_set_pos(mset, -1/*x0*/, -1/*y0*/, 23/*w*/, 0/*h*/, 1/*cols*/);
        menu_set_erase_on_exit(mset, 1);
        menu_set_features(mset, MENU_FEATURES_TEXTCENTER);

        menu_reset_items(mitems);
        menu_add_item(mitems, "Change Logo"        , 0/*tag*/);
        menu_add_item(mitems, "Modify Palette"     , 1/*tag*/);
        menu_add_item(mitems, "Starfield Count"    , 2/*tag*/);
        menu_add_item(mitems, "Starfield Color"    , 3/*tag*/);
        menu_add_item(mitems, "Backup Memory TB"   , 4/*tag*/);
        menu_add_item(mitems, "Cart Dump Tests"    , 5/*tag*/);
        menu_add_item(mitems, "BupLib Stack Test"  , 6/*tag*/);
        menu_add_item(mitems, "SMPC Pad Test"      , 7/*tag*/);
        menu_add_item(mitems, "BUP Time Test Bench", 8/*tag*/);
        menu_add_item(mitems, "IGR Handler Dump"   , 9/*tag*/);

        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);

        if(mset->exit_code == MENU_EXIT_CANCEL)
        {
            return;
        }

        char file_path[SC_PATHNAME_MAXLEN];
        int ret;
        if(menu_selected == 0)
        {
            /* Select logo from folder in CDROM. */
            unsigned char dev_id_tmp = SC_FILE_CDROM;
            file_path[0] = '\0';

            ret = browser_select_file(
                    &dev_id_tmp, file_path, NULL/*curr_sel_file*/, 
                    FB_FLAG_LIST_FOLDERS | FB_FLAG_BROWSE_DEVICE | FB_FLAG_BROWSE_FOLDER, 
                    ".BIN", 
                    NULL/* default help message. */);

            if(ret)
            {
                dbg_print("[Logo]Loading \"%s\" ...", file_path);

                logo_load_params_t load_params;

                memset(&load_params, 0, sizeof(logo_load_params_t));
                load_params.dev_id    = dev_id_tmp;
                load_params.file_path = file_path;
                load_params.compressed = 0;

                logo_load(&load_params);

                extra_wait_for_start(NULL);
            }
        }
        else if(menu_selected == 1)
        {
            if(mset->exit_code == MENU_EXIT_OK)
            {
                extra_palmodif_change();
            }
        }
        else if(menu_selected == 2)
        {
            if(sf_count == 0)
            {
                sf_count = 20;
            }
            else if(sf_count == STARS_MAXCOUNT)
            {
                sf_count = 0;
            }
            else
            {
                sf_count = sf_count*2;
            }

            if(sf_count >= STARS_MAXCOUNT)
            {
                sf_count = STARS_MAXCOUNT;
            }
            sf_set_star_count(sf_count);
            dbg_print("[Extra]sf_set_star_count(%d)", sf_count);
        }
        else if(menu_selected == 3)
        {
            if(mset->exit_code == MENU_EXIT_OK)
            {
                /* Change starfield star colors. */
                sf_color = (sf_color ? 0 : 1);
                sf_init(sf_color);
                sf_set_star_count(sf_count);
                dbg_print("[Extra]sf_init(%d)", sf_color);
            }
        }
        else if(menu_selected == 4)
        {
            /* Show selection menu for the following actions :
             *  - Test vmem access in internal backup memory
             *  - Test cartridge backup memory integrity : cartridge fill
             *  - Test cartridge backup memory integrity : contents check
             */
            bupmem_test_bench();
        }
        else if(menu_selected == 5)
        {
            cartridge_dump_test();
        }
        else if(menu_selected == 6)
        {
            buplib_stack_test();
        }
        else if(menu_selected == 7)
        {
            smpc_pad_test();
        }
        else if(menu_selected == 8)
        {
            bup_time_test();
        }
        else if(menu_selected == 9)
        {
            igr_handler_dump();
        }
    }
}


void start_homebrew(void)
{
    unsigned char dev_id;
    char file_path[SC_PATHNAME_MAXLEN];
    unsigned long load_length;
    void* ram_adr;
    int ret;

    /* Init SatCom. */
    bup_satcom_init();

    /* Select file to load.
     *
     * Initial path = CDROM, "/APPS" directory.
     * But in the case of SD card from top cartridge or Satiator being detected
     * then browse from there by default.
     * 
     * In the case both top cartridge and Satiator are detected, priority is put
     * on on SD card from top cartridge like Gamer's Cartridge or Wasca etc.
     * Reason is that user is more likely to remove top cartridge than Satiator.
     *
     * APPS folder may not exist on SD card, so in order to avoid weird behavior
     * initial path is set to root folder in this case.
     */
    dev_id = sc_get_sdcard_devid();
    if(SC_FILE_IS_VALID(dev_id))
    {
        file_path[0] = '\0';
    }
    else
    {
        dev_id = SC_FILE_CDROM;
        strcpy((void*)file_path, "/APPS");
    }

    ret = browser_select_file(
            &dev_id, file_path, NULL/*curr_sel_file*/, 
            FB_FLAG_LIST_FOLDERS | FB_FLAG_BROWSE_DEVICE | FB_FLAG_BROWSE_FOLDER, 
            ".bin", 
            NULL/* default help message. */);
    if(ret == 0)
    {
        return;
    }

    scd_logout("[homebrew]scf_size(file_path=%s) ...", file_path);
    load_length = scf_size(dev_id, file_path);
    scd_logout("[homebrew]File size = %d bytes (%s)", load_length, file_path);
    if(load_length == 0)
    {
        return;
    }

    /* This program runs in HRAM.
     * So first read binary into LRAM, and 
     * copy/execute it to usual 0600400
     * address in copystub_execute function
     */
    ram_adr = (void*)0x00200000;

    /* Perform registers soft reset. */
    soft_reset(SC_SOFTRES_ALL);

    scd_logout("[homebrew]scf_read(file_path=%s, len=%d) ...", file_path, load_length);
    load_length = scf_read(dev_id, file_path, 0/*offset*/, load_length, ram_adr);
    if(load_length == 0)
    {
        pseudo_sysres();
    }

    /* SatCom isn't initialized yet, 
     * so calling sc_execute function is forbidded, 
     * hence copystub_execute function is called instead.
     * (HRAM/LRAM are cleared in copystub_execute function.)
     */
    copystub_execute(SC_SOFTRES_ALL, (unsigned long)ram_adr/*tmp*/, load_length, 0x06004000/*exec*/);
}


void dbginfo_show(void)
{
    while(1)
    {
        int row = 3;

        conio_printf( 2, row  , COLOR_YELLOW, "BUP_Init: ");
        conio_printf(12, row++, COLOR_WHITE , "%08X", BUP_Init);
        row++;

        conio_printf( 2, row++, COLOR_YELLOW, "Entry points :");

        conio_printf( 3, row  , COLOR_YELLOW, "SelPart:          Format :");
        conio_printf(12, row  , COLOR_WHITE , "%08X", BUP_SelPart);
        conio_printf(30, row++, COLOR_WHITE , "%08X", BUP_Format);

        conio_printf( 3, row  , COLOR_YELLOW, "Stat   :          Write  :");
        conio_printf(12, row  , COLOR_WHITE , "%08X", BUP_Stat);
        conio_printf(30, row++, COLOR_WHITE , "%08X", BUP_Write);

        conio_printf( 3, row  , COLOR_YELLOW, "Read   :          Delete :");
        conio_printf(12, row  , COLOR_WHITE , "%08X", BUP_Read);
        conio_printf(30, row++, COLOR_WHITE , "%08X", BUP_Delete);

        conio_printf( 3, row  , COLOR_YELLOW, "Dir    :          Verify :");
        conio_printf(12, row  , COLOR_WHITE , "%08X", BUP_Dir);
        conio_printf(30, row++, COLOR_WHITE , "%08X", BUP_Verify);

        conio_printf( 3, row  , COLOR_YELLOW, "GetDate:          SetDate:");
        conio_printf(12, row  , COLOR_WHITE , "%08X", BUP_GetDate);
        conio_printf(30, row++, COLOR_WHITE , "%08X", BUP_SetDate);
        row++;

        conio_printf( 2, row  , COLOR_YELLOW, "BupConfig          : ");
        conio_printf(23, row++, COLOR_WHITE , "%08X", _bupConf);
        row++;

        conio_printf( 2, row  , COLOR_YELLOW, "Work RAM (8KB)     : ");
        conio_printf(23, row++, COLOR_WHITE , "%08X", _bupRamWork);
        conio_printf( 3, row++, COLOR_WHITE , "%08X %08X %08X %08X", 
            _bupRamWork[   0], _bupRamWork[   1], _bupRamWork[   0], _bupRamWork[   1]);
        conio_printf( 3, row++, COLOR_WHITE , "%08X %08X %08X %08X", 
            _bupRamWork[2045], _bupRamWork[2046], _bupRamWork[2047], _bupRamWork[2048]);
        row++;

        conio_printf( 2, row  , COLOR_YELLOW, "Library RAM (16KB) : ");
        conio_printf(23, row++, COLOR_WHITE , "%08X", _bupLibrary);
        conio_printf( 3, row++, COLOR_WHITE , "%08X %08X %08X %08X", 
            _bupLibrary[   0], _bupLibrary[   1], _bupLibrary[   0], _bupLibrary[   1]);
        conio_printf( 3, row++, COLOR_WHITE , "%08X %08X %08X %08X", 
            _bupLibrary[4093], _bupLibrary[4094], _bupLibrary[4095], _bupLibrary[4096]);
        row++;

        conio_printf( 2, row  , COLOR_YELLOW, "Partitions infos : ");
        conio_printf(23, row++, COLOR_WHITE , "cnt=%d, btf=0x%02X", _whole_part_cnt, _whole_part_list);

        if(wait_for_start("Start: Exit, B: Re-init library"))
        {
            break;
        }
        else
        {
            /* Re-init library.
             * Purpose : verify that vmem parameters, etc
             * are not modified after BUP library re-init.
             */
            buplib_init();
        }
    }
}

void cartrom_hexview(void)
{
    int i, j;
    pad_t* pad;

    unsigned long ptr = 0x02000000;
    unsigned long offset = 0;

    while(1)
    {
        WaitForVBLANKIn();
        WaitForVBLANKOut();

        /* Refresh dump display, in order to spot furtive memory error. */
        int row = 3;
        conio_printf(2, row++, COLOR_YELLOW, "Start Address = 0x%08X", ptr + offset);

#define LINE_COUNT    6
#define CHAR_PER_LINE 8
        for(j=0; j<LINE_COUNT; j++)
        {
            /* Hexview stuff (8 bit mode). */
            conio_printf(2, row, COLOR_YELLOW, "+%02X:", j*CHAR_PER_LINE);
            for(i=0; i<CHAR_PER_LINE; i++)
            {
                unsigned char c = *((unsigned char*)(ptr+offset + j*CHAR_PER_LINE+i));
                conio_printf(2+4+i*3  , row, COLOR_WHITE, "%02X", c);
                conio_printf(2+4+8*3+i, row, COLOR_WHITE, "%c"  , char2pchar(c));
            }

            /* Hexview stuff (16 bit mode). */
            conio_printf(2, row+(LINE_COUNT+1), COLOR_YELLOW, "+%02X:", j*CHAR_PER_LINE);
            for(i=0; i<CHAR_PER_LINE; i+=sizeof(unsigned short))
            {
                unsigned short c = *((unsigned short*)(ptr+offset + j*CHAR_PER_LINE+i));
                conio_printf(2+4+i*3, row+(LINE_COUNT+1), COLOR_WHITE, "%04X", c);
                conio_printf(2+4+8*3, row+(LINE_COUNT+1), COLOR_WHITE, "(16 bit)");
            }

            /* Hexview stuff (32 bit mode). */
            conio_printf(2, row+(LINE_COUNT+1)*2, COLOR_YELLOW, "+%02X:", j*CHAR_PER_LINE);
            for(i=0; i<CHAR_PER_LINE; i+=sizeof(unsigned long))
            {
                unsigned long c = *((unsigned long*)(ptr+offset + j*CHAR_PER_LINE+i));
                conio_printf(2+4+i*3, row+(LINE_COUNT+1)*2, COLOR_WHITE, "%08X", c);
                conio_printf(2+4+8*3, row+(LINE_COUNT+1)*2, COLOR_WHITE, "(32 bit)");
            }

            row++;
        }

        conio_printf(2, 25, COLOR_WHITE , "L/R: Change Address, Start/B: Exit");

        pad = pad_read();
        if((pad->delta[0] & PAD_START)
        || (pad->delta[0] & PAD_B    ))
        {
            return;
        }

        if(pad->delta[0] & PAD_LBUTTON)
        {
            if(offset != 0)
            {
                offset -= LINE_COUNT*CHAR_PER_LINE;
            }
        }

        if(pad->delta[0] & PAD_RBUTTON)
        {
            offset += LINE_COUNT*CHAR_PER_LINE;
        }

        /* Animate startfield. */
        bup_anim_starfield();
    }
}


void do_commslink(void)
{
    pad_t* pad;

    commslink_status_t* stat = &_commslink_stat;

    int row = 3;
    conio_printf( 2, row++, COLOR_YELLOW, "     ~~~ Commslink Transfer ~~~     ");
    row++;
    conio_printf( 2, row++, COLOR_WHITE , "Action Replay, Gameshark and other  ");
    conio_printf( 2, row++, COLOR_WHITE , "equivalent cartridges featuring DB25");
    conio_printf( 2, row++, COLOR_WHITE , "connector are supported.            ");
    row++;
    conio_printf( 2, row++, COLOR_WHITE , "Extra device is required to connect ");
    conio_printf( 2, row++, COLOR_WHITE , "to a PC, for example USB Data Link  ");
    conio_printf( 2, row++, COLOR_WHITE , "or Yano/Exstand/Freewing converters ");
    conio_printf( 2, row++, COLOR_WHITE , "or even antique Comm Link ISA card. ");

    int count = 1000;
    while(1)
    {
        WaitForVBLANKIn();
        WaitForVBLANKOut();

        /* Display transfer status on screen, however
         * there's no need to do that too frequently.
         */
        count++;
        if(count >= 30)
        {
            count = 0;

            row = 15;
            if(stat->comms_type != COMMS_TYPE_NONE)
            {
                conio_printf( 2, row  , COLOR_WHITE , "Commslink Type : ");
                conio_printf(19, row++, COLOR_YELLOW, "%s", (stat->comms_type == COMMS_TYPE_EMS ? "EMS  " : "Datel"));
            }
            else
            {
                conio_printf( 2, row++, COLOR_TRANSPARENT, empty_line);
            }
            row++;

            conio_printf( 2, row  , COLOR_WHITE , "Transaction count : ");
            conio_printf(22, row++, COLOR_YELLOW, "%5u", stat->tr_count);
            row++;

            conio_printf( 2, row  , COLOR_WHITE , "Rcv. Bytes : ");
            conio_printf(17, row++, COLOR_YELLOW, "%10u Bytes", stat->rcv_count);
            conio_printf(20, row++, COLOR_YELLOW, "%7u KB", stat->rcv_count >> 10);
            row++;

            conio_printf( 2, row  , COLOR_WHITE , "Send Bytes : ");
            conio_printf(17, row++, COLOR_YELLOW, "%10u", stat->snd_count);
            conio_printf(20, row++, COLOR_YELLOW, "%7u KB", stat->snd_count >> 10);
        }

        conio_printf(2, 25, COLOR_WHITE , "Z: Reset Stats, A/B/C/Start: Exit");

        pad = pad_read();

        /* A/B/C/Start : exit to parent menu. */
        if(pad->delta[0] & (PAD_A|PAD_B|PAD_C|PAD_START))
        {
            break;
        }

        /* Z button : reset transfer statistics. */
        if(pad->new[0] & PAD_Z)
        {
            memset(stat, 0, sizeof(commslink_status_t));
        }

        /* Animate startfield. */
        bup_anim_starfield();
    }

    clear_screen();
}


#if 1

/* Include the definition of BIOS dump file name. */
#include "fenrir_fileio.h"

void bios_to_ode(void)
{
    /* If Satiator/Gamer's Cartridge/etc not available, dump to Fenrir. */
    unsigned char dev_id;

    dev_id = sc_get_sdcard_devid();
    if(!SC_FILE_IS_VALID(dev_id))
    {
        dev_id = SC_FILE_EXTRA;
    }

    if(dev_id != SC_FILE_EXTRA)
    {
        conio_printf(2,  4, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "---     BIOS Dump to SD Card     ---");
    }
    else
    {
        /* Warn the user that this operation is very slow. */
        conio_printf(2,  4, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "---        BIOS Dump to ODE      ---");

        conio_printf(2,  6, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "Warning : this operation will take  ");
        conio_printf(2,  7, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "around one hour to terminate !      ");

        conio_printf(2,  9, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "Please do not turn off the Saturn   ");
        conio_printf(2, 10, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "while data is being written !!!     ");
    }

    if(wait_for_start("Start: continue, B: Go Back"))
    {
        unsigned char* src = (unsigned char*)(0x00000000);
        unsigned char* ptr = (unsigned char*)BUP_BUFFER_ADR;
        unsigned long size = 512*1024;
        unsigned long i;

        char filename[SC_PATHNAME_MAXLEN];
        strcpy(filename, "/" FENRIR_BIOS_DUMP_FILE);

        conio_printf(2, 12, COLOR_YELLOW, "Copying BIOS data ...");
        for(i=0; i<size; i++)
        {
            ptr[i] = src[i];
        }

        conio_printf(2, 13, COLOR_YELLOW, "Write to [%s]%s", scf_dev_get_long_name(dev_id), filename);
        if(scf_write((void*)ptr, size, dev_id, filename))
        {
            conio_printf(2, 14, COLOR_WHITE, "BIOS dump ended !");
        }

        wait_for_start("Press Start to exit");
    }

    clear_screen();
}

#else

/* Special version that consecutively dumps the BIOS eight times. */
void bios_to_ode(void)
{
    /* Warn the user that this operation is very slow. */
    conio_printf(2,  4, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "---        BIOS Dump to ODE      ---");
    conio_printf(2,  5, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), empty_line);
    conio_printf(2,  6, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "Warning : this operation will take  ");
    conio_printf(2,  7, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "around eight hours to terminate !   ");
    conio_printf(2,  8, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), empty_line);
    conio_printf(2,  9, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "Please do not turn off the Saturn   ");
    conio_printf(2, 10, COLOR_BG_FG(COLOR_YELLOW, COLOR_BLACK), "while data is being written !!!     ");

    /* Select target device :
     *  - Fenrir   : SC_FILE_EXTRA
     *  - Satiator : SC_FILE_SATIATOR
     */
    //unsigned char dev_id = SC_FILE_EXTRA;
    unsigned char dev_id = SC_FILE_SATIATOR;

    if(wait_for_start("Start: continue, B: Go Back"))
    {
        int i;
        for(i=0; i<(dev_id == SC_FILE_EXTRA ? 8 : 100); i++)
        {
            unsigned char* src = (unsigned char*)(0x00000000);
            unsigned char* ptr = (unsigned char*)BUP_BUFFER_ADR;
            unsigned long size = 512*1024;
            unsigned long j;

            char filename[SC_PATHNAME_MAXLEN];
            //strcpy(filename, "/" FENRIR_BIOS_DUMP_FILE);
            sprintf(filename, "/SATURN_BIOS%03u.BIN", (unsigned int)(i+1));

            for(j=0; j<size; j++)
            {
                ptr[j] = src[j];
            }

            conio_printf(2, 12 + (i % 12), COLOR_YELLOW, "Dump BIOS to \"%s\" ...", filename);
            scf_write((void*)ptr, size, dev_id, filename);
        }

        wait_for_start("Press Start to exit");
    }

    clear_screen();
}

#endif

