/**
 *  Saturn Save Data Manager
 *  by cafe-alpha.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/
#ifndef _EXTRA_MENU_H_
#define _EXTRA_MENU_H_

#include <sc_saturn.h>

/**
 * extra_menu
 *
 * Prompt for extra (debug) features.
**/
void extra_menu(void);

/**
 * start_homebrew
 *
 * Browse a file and execute it from 0x06004000 address.
**/
void start_homebrew(void);

/**
 * dbginfo_show
 *
 * Show debug informations.
**/
void dbginfo_show(void);

/**
 * cartrom_hexview
 *
 * Hex-display cartridge ROM contents.
**/
void cartrom_hexview(void);

/**
 * do_commslink
 *
 * Operate PC communication with Commslink-compatible cartridge.
**/
void do_commslink(void);

/**
 * bios_to_ode
 *
 * Dump BIOS to ODE's mass storage media.
 * Warning : it's super slow.
**/
void bios_to_ode(void);

#endif /* _EXTRA_MENU_H_ */

