/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#include <sc_saturn.h>

#include "../pskai_settings.h"

#include "bup_menus.h" // DEVICE_ID_BRAM definition

/* Data in order to get/set SatCom settings data from/to backup memory. */
sc_settings_t _satcom_settings;


void pskai_settings_read(void)
{
    pskai_settings_t* set = (pskai_settings_t*)(_satcom_settings.extra_dat);
    memset((void*)set, 0, sizeof(pskai_settings_t));

    /* Read settings from internal backup memory, and set back
     * some of them into their respective locations.
     */
    Sint32 ret;
    BupDir tb;
    memset(&tb, 0, sizeof(BupDir));
    ret = BUP_Dir(DEVICE_ID_BRAM, (Uint8 *)BRAMSET_NAME, 1, &tb);

    // scd_logout("BUP_Dir:%d [datasize:%u]", ret, tb.datasize);

    if((ret == 1)
    && (tb.datasize == sizeof(bram_settings_t)))
    {
        bram_settings_t bram_set;
        memset(&bram_set, 0, sizeof(bram_settings_t));

        ret = BUP_Read(DEVICE_ID_BRAM, tb.filename, (volatile Uint8*)&bram_set);
        // scd_logout("BUP_Read(%s):%d", tb.filename, ret);

        /* Discard old and/or invalid settings. */
        if(bram_set.init == PSKAI_SETTINGS_INITVAL)
        {
            memcpy(&(set->bram), &bram_set, sizeof(bram_settings_t));
        }
    }
}
