!
! Cheat Codes for Pseudo Saturn Kai
! by cafe-alpha and Yabause Team.
! WWW: http://ppcenter.free.fr/pskai/
!
! See LICENSE file for details.
!

/*
 * Copyright (c) 2006-2012 Israel Jacquez <mrkotfw@gmail.com>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


.text
.align 2

!; Cheat codes handler : cartridge ROM based implementation
!;
!; This module is executed by cheat codes interrupt bootstrap handler, with
!; the following parameters provided :
!;  - R4 : pointer to configuration memory
!;
!; After backing up all parameters to interrupt context memory (in stack), 
!; cheat codes handler user function (C language) is called with the
!; parameters below :
!;  - R4 : pointer to configuration memory
!;  - R5 : pointer to interrupt context memory

.global _asm_cheatcodes_hdlr_rom
.type _asm_cheatcodes_hdlr_rom, @function
_asm_cheatcodes_hdlr_rom:
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15
        sts.l  pr,@-r15

        !; Provide pointer to break context data as second
        !; parameter to cheat codes handler user function
        mov    r15,r5
        add    #0x4,r5          !; Discard backup of PC register
        nop
        !; Call cheat codes handler user function
        mov.l _int_cheats_function_start,r0

        jsr @r0
        nop

        lds.l  @r15+,pr
        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5

        rts
        nop


!; Interrupt handler upper level function in cheat_codes_hdlr_rom_user.c file.
.align 4
.import _cheats_user_hdlr_rom
_int_cheats_function_start:    .long _cheats_user_hdlr_rom

