/**
 *  Sega Saturn cheat codes for Pseudo Saturn Kai
 *  by cafe-alpha and CyberWarriorX.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#ifndef _CHEAT_CODES_ROM_EXEC_H_
#define _CHEAT_CODES_ROM_EXEC_H_

/* Definition of sc_rom_code_header_t structure. */
#include "../../satcom_lib/sc_rom_code.h"

/* Cheat codes related structure and data definitions. */
#include "cheats_codes.h"

/* Extra address for ROM-less codes. */
#include "../romless_defs.h"


/* ROM code header and entry point definitions. */
#ifdef PSKAI_LITE_BUILD
#   define ROM_CHEATS_START (0x0203EC00)
#else // !PSKAI_LITE_BUILD
#   define ROM_CHEATS_START (0x0205C000)
#endif // !PSKAI_LITE_BUILD

#define ROM_CHEATS_HDR_ADDRESS(_ROMLESS_) ((sc_rom_code_header_t*)(_ROMLESS_ ? ROMLESS_CHEATS_START : ROM_CHEATS_START))
#define ROM_CHEATS_EXEC_ADDRESS(_ROMLESS_) ((_ROMLESS_ ? ROMLESS_CHEATS_START : ROM_CHEATS_START) + sizeof(sc_rom_code_header_t))



/**
 * Function     : rc_cheats_romcode_check
 * Description  : Verify if cheat codes ROM code is present or not.
 * Returns      : 0: can't use cheat codes.
 *                else: can use cheat codes.
**/
#define rc_cheats_romcode_check(_ROMLESS_) ((ROM_CHEATS_HDR_ADDRESS(_ROMLESS_)->magic_42 == 0x42) && (ROM_CHEATS_HDR_ADDRESS(_ROMLESS_)->magic_53 == 0x53) ? 1 : 0)



/**
 * Function     : rc_cheats_get_entry_points
 * Description  : Retrieve cheat codes related ROM code entry points.
 * Parameter #1 : ct_entrypoints_t* entry_points_ptr : array used to store entry points
**/
typedef struct _ct_entrypoints_t
{
    /**
     * ROM code entry point #0 : cheats_rcf_version
     * Write version information in input structure.
    **/
    void (*version)(ct_version_t*);

    /**
     * ROM code entry point #1 : cheats_rcf_getcodes
     * Return pointer to address/code list.
    **/
    ct_code_t* (*getcodes)(void);

    /**
     * ROM code entry point #2 : cheats_rcf_apply
     * Apply cheat codes set-up in config memory.
     * Returns pointer to 1st stage handler function.
    **/
    void* (*apply)(ct_apply_params_t* p);

    /**
     * ROM code entry point #3 : cheats_rcf_sysres
     * Perform system reset instead of soft reset command.
    **/
    void (*sysres)(void);
} ct_entrypoints_t;
#define rc_cheats_get_entry_points(_ROMLESS_, _EP_) (((void (*)(ct_entrypoints_t* entry_points_ptr))(ROM_CHEATS_EXEC_ADDRESS(_ROMLESS_)))(_EP_))


#endif /* _CHEAT_CODES_ROM_EXEC_H_ */
