/**
 *  Sega Saturn cheat codes for Pseudo Saturn Kai - Debug Stuff
 *  by cafe-alpha
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#ifndef _INTERRUPT_DEBUG_H_
#define _INTERRUPT_DEBUG_H_

/* Inclusion of ihr_break_context_t structure :
 *
 * typedef struct _ihr_break_context_t
 * {
 *     -- Stage 3/3 :
 *     -- Registers saved by second stage cheat codes
 *     -- IHR handler in cheat_codes_hdlr_rom.s file.
 *     -- 
 *     unsigned long mach;
 *     unsigned long macl;
 *     unsigned long vbr;
 *     unsigned long gbr;
 *     
 *     unsigned long r15;
 *     unsigned long r14;
 *     unsigned long r13;
 *     unsigned long r12;
 *     unsigned long r11;
 *     unsigned long r10;
 *     unsigned long r9;
 *     unsigned long r8;
 *     unsigned long r7;
 *     unsigned long r6;
 *     unsigned long r5;
 *     -- R4 is saved in stage 2/3.
 *     unsigned long r3;
 *     unsigned long r2;
 *     unsigned long r1;
 *     -- R0 is saved in stage 2/3.
 *     
 *     -- Stage 2/3 :
 *     -- Registers saved by first stage cheat codes
 *     -- IHR handler in debug_ihr.s file.
 *     -- 
 *     unsigned long r4;
 *     unsigned long r0;
 *     unsigned long pr;
 *     
 *     -- Stage 1/3 :
 *     -- Registers saved by CPU when interrupt is triggered.
 *     -- 
 *     unsigned long pc;
 *     unsigned long sr;
 * } ihr_break_context_t;
 * 
 */
#include "../../../satcom_lib/satcart.h"


/**
 * Start debugger :
 *  - Setup exception interrupt handlers.
 *  - Reset UBC settings and setup UBC interrupt handler.
 *  - Enable interrupts handler.
**/
void debugger_start(void);


/**
 * Stop debugger.
**/
void debugger_stop(void);



#endif /* _INTERRUPT_DEBUG_H_ */
