/**
 *  Sega Saturn cheat codes for Pseudo Saturn Kai - USB connectivity module
 *  by cafe-alpha
 *
 *  USB transfer code adapted from Sega Saturn USB flash cart ROM
 *  Copyright c 2012, 2015 Anders Montonen
 *
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#ifndef CHEATS_USB_DEV_CART_H
#define CHEATS_USB_DEV_CART_H

#include <stdio.h>

#include "../cheats_codes.h"

/**
 * Verify status of USB connectivity, and if required, 
 * do USB transfer with PC.
 *
 * Note: this function is called from assembly interrupt
 *       handler, hence care is required when changing
 *       this function's prototype.
**/
void usb_transfer_check(ihr_break_context_t* context);

/**
 * sc_usb_is_port_available
 *
 * Check if USB port is available or not.
 * Returns 0 if USB dev cart not detected.
 * Returns 1 if USB port detected.
**/
int usb_is_port_available(void);

/**
 * sc_usb_is_connected
 *
 * Check if USB cable is connected or not.
 * Returns 0 if USB dev cart not detected.
 * Returns 0 if no USB cable connected.
 * Returns 1 if USB cable connected.
**/
int usb_is_connected(void);


#endif
