!
! Cheat Codes for Pseudo Saturn Kai
! by cafe-alpha and Yabause Team.
! WWW: http://ppcenter.free.fr/pskai/
!
! See LICENSE file for details.
!

/*
 * Copyright (c) 2006-2012 Israel Jacquez <mrkotfw@gmail.com>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


.text
.align 2

.global _asm_int_vector_base_get
.type _asm_int_vector_base_get, @function
_asm_int_vector_base_get:
        stc vbr, r0
        rts
        nop



!; Interrupt handler for exceptions and UBC stuff.
.global _asm_ex_general_illegal_instruction_ihr
.type _asm_ex_general_illegal_instruction_ihr, @function
_asm_ex_general_illegal_instruction_ihr:
        sts.l  pr,@-r15
        mov.l  r0,@-r15
        mov.l  r1,@-r15
        mov.l  r2,@-r15
        mov.l  r3,@-r15
        mov.l  r4,@-r15
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15

        !; Provide pointer to break context data to user function
        nop
        mov    r15,r4
        nop

        !; Call user function
        mov.l _int_general_illegal_instruction_function_start, r0
        nop
        jsr @r0
        nop

        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5
        mov.l  @r15+,r4
        mov.l  @r15+,r3
        mov.l  @r15+,r2
        mov.l  @r15+,r1
        mov.l  @r15+,r0
        lds.l  @r15+,pr

        rte         !; Jump back to original instuction
        nop


.global _asm_ex_slot_illegal_instruction_ihr
.type _asm_ex_slot_illegal_instruction_ihr, @function
_asm_ex_slot_illegal_instruction_ihr:
        sts.l  pr,@-r15
        mov.l  r0,@-r15
        mov.l  r1,@-r15
        mov.l  r2,@-r15
        mov.l  r3,@-r15
        mov.l  r4,@-r15
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15

        !; Provide pointer to break context data to user function
        nop
        mov    r15,r4
        nop

        !; Call user function
        mov.l _int_slot_illegal_instruction_function_start, r0
        nop
        jsr @r0
        nop

        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5
        mov.l  @r15+,r4
        mov.l  @r15+,r3
        mov.l  @r15+,r2
        mov.l  @r15+,r1
        mov.l  @r15+,r0
        lds.l  @r15+,pr

        rte         !; Jump back to original instuction
        nop


.global _asm_ex_cpu_address_error_ihr
.type _asm_ex_cpu_address_error_ihr, @function
_asm_ex_cpu_address_error_ihr:
        sts.l  pr,@-r15
        mov.l  r0,@-r15
        mov.l  r1,@-r15
        mov.l  r2,@-r15
        mov.l  r3,@-r15
        mov.l  r4,@-r15
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15

        !; Provide pointer to break context data to user function
        nop
        mov    r15,r4
        nop

        !; Call user function
        mov.l _int_cpu_address_error_function_start, r0
        nop
        jsr @r0
        nop

        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5
        mov.l  @r15+,r4
        mov.l  @r15+,r3
        mov.l  @r15+,r2
        mov.l  @r15+,r1
        mov.l  @r15+,r0
        lds.l  @r15+,pr

        rte         !; Jump back to original instuction
        nop


.global _asm_ex_dma_address_error_ihr
.type _asm_ex_dma_address_error_ihr, @function
_asm_ex_dma_address_error_ihr:
        sts.l  pr,@-r15
        mov.l  r0,@-r15
        mov.l  r1,@-r15
        mov.l  r2,@-r15
        mov.l  r3,@-r15
        mov.l  r4,@-r15
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15

        !; Provide pointer to break context data to user function
        nop
        mov    r15,r4
        nop

        !; Call user function
        mov.l _int_dma_address_error_function_start, r0
        nop
        jsr @r0
        nop

        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5
        mov.l  @r15+,r4
        mov.l  @r15+,r3
        mov.l  @r15+,r2
        mov.l  @r15+,r1
        mov.l  @r15+,r0
        lds.l  @r15+,pr

        rte         !; Jump back to original instuction
        nop


.global _asm_ubc_ihr
.type _asm_ubc_ihr, @function
_asm_ubc_ihr:
        sts.l  pr,@-r15
        mov.l  r0,@-r15
        mov.l  r1,@-r15
        mov.l  r2,@-r15
        mov.l  r3,@-r15
        mov.l  r4,@-r15
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15

        !; Provide pointer to break context data to user function
        nop
        mov    r15,r4
        nop

        !; Call user function
        mov.l _int_ubc_function_start, r0
        nop
        jsr @r0
        nop

        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5
        mov.l  @r15+,r4
        mov.l  @r15+,r3
        mov.l  @r15+,r2
        mov.l  @r15+,r1
        mov.l  @r15+,r0
        lds.l  @r15+,pr

        rte         !; Jump back to original instuction
        nop



.global _asm_usb_transfer_ihr
.type _asm_usb_transfer_ihr, @function
_asm_usb_transfer_ihr:
        sts.l  pr,@-r15
        mov.l  r0,@-r15
        mov.l  r1,@-r15
        mov.l  r2,@-r15
        mov.l  r3,@-r15
        mov.l  r4,@-r15
        mov.l  r5,@-r15
        mov.l  r6,@-r15
        mov.l  r7,@-r15
        mov.l  r8,@-r15
        mov.l  r9,@-r15
        mov.l  r10,@-r15
        mov.l  r11,@-r15
        mov.l  r12,@-r15
        mov.l  r13,@-r15
        mov.l  r14,@-r15
        mov.l  r15,@-r15
        stc.l  gbr,@-r15
        stc.l  vbr,@-r15
        sts.l  macl,@-r15
        sts.l  mach,@-r15

        !; Provide pointer to break context data to user function
        nop
        mov    r15,r4
        nop

        !; Call user function
        mov.l _int_usb_transfer_function_start, r0
        nop
        jsr @r0
        nop

        lds.l  @r15+,mach       !; Restore original regs from stack (or PC modified)
        lds.l  @r15+,macl
        ldc.l  @r15+,vbr
        ldc.l  @r15+,gbr
        add    #0x4,r15         !; Skip r15 restore
        mov.l  @r15+,r14
        mov.l  @r15+,r13
        mov.l  @r15+,r12
        mov.l  @r15+,r11
        mov.l  @r15+,r10
        mov.l  @r15+,r9
        mov.l  @r15+,r8
        mov.l  @r15+,r7
        mov.l  @r15+,r6
        mov.l  @r15+,r5
        mov.l  @r15+,r4
        mov.l  @r15+,r3
        mov.l  @r15+,r2
        mov.l  @r15+,r1
        mov.l  @r15+,r0
        lds.l  @r15+,pr

        rte         !; Jump back to original instuction
        nop



!; Interrupt handler upper level functions, defined in debug/debugger.c file.
.align 4
.import _general_illegal_instruction_user_ihr
_int_general_illegal_instruction_function_start:    .long _general_illegal_instruction_user_ihr
.import _slot_illegal_instruction_user_ihr
_int_slot_illegal_instruction_function_start:       .long _slot_illegal_instruction_user_ihr
.import _cpu_address_error_user_ihr
_int_cpu_address_error_function_start:              .long _cpu_address_error_user_ihr
.import _dma_address_error_user_ihr
_int_dma_address_error_function_start:              .long _dma_address_error_user_ihr
.import _ubc_user_ihr
_int_ubc_function_start:                            .long _ubc_user_ihr

!; Interrupt handler upper level functions for "USB only" mode, defined in debug/usb_dev_cart.c file.
.import _usb_transfer_check
_int_usb_transfer_function_start:                   .long _usb_transfer_check

