/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/


#include <stdio.h>
#include <string.h>

#include <sc_saturn.h>

#include "color_tester.h"

#include "conio.h"
#include "main.h"
#include "menu.h"
#include "vdp.h"

#if USE_COLOR_TESTER == 1

#define COLOR_LUT_CNT 7
unsigned char _palmodif_color_lut[COLOR_LUT_CNT] =
{
    /* Title */
    COLOR_YELLOW, /* Back    */
    COLOR_RED   , /* Front   */
    /* Item */
    COLOR_WHITE , /* Back    */
    COLOR_BLACK , /* Front   */
    COLOR_GRAY  , /* Grey #1 */
    COLOR_SILVER, /* Grey #2 */
    COLOR_BLUE  , /* Border  */
};

int _palmodif_col = 0;
int _palmodif_row = 0;
void color_tester_keypress(pad_t* pad, int initial_release_wait, int stag)
{
    int id;
    volatile unsigned short *vdp2_cram = (volatile unsigned short *)VDP2_CRAM;

    if(pad)
    {
        if(pad->delta[0] & PAD_LEFT)
        {
            if(_palmodif_col != 0)
            {
                _palmodif_col = _palmodif_col-1;
            }
        }
        else if(pad->delta[0] & PAD_RIGHT)
        {
            if(_palmodif_col != 2)
            {
                _palmodif_col = _palmodif_col+1;
            }
        }
        // else if(pad->delta & PAD_UP)
        // {
            // if(_palmodif_row != 16)
            // {
                // _palmodif_row--;
            // }
            // else
            // {
                // _palmodif_row = 31;
            // }
        // }
        // else if(pad->delta & PAD_DOWN)
        // {
            // if(_palmodif_row != 31)
            // {
                // _palmodif_row++;
            // }
            // else
            // {
                // _palmodif_row = 16;
            // }
        // }
    }

    /* Display palette configuration. */
    for(id=0; id<COLOR_LUT_CNT; id++)
    {
        if(_palmodif_color_lut[id] == 0xFF)
        {
            /* Skip disabled items. */
            continue;
        }

        char sel[6];
        unsigned short col = vdp2_cram[_palmodif_color_lut[id]];

        sel[0] = ' '; sel[1] = ' ';
        sel[2] = ' '; sel[3] = ' ';
        sel[4] = ' '; sel[5] = ' ';
        if(id == _palmodif_row)
        {
            sel[_palmodif_col*2+0] = 26; sel[_palmodif_col*2+1] = 27;
        }

        conio_font_printf(FONT_DEFAULT, FONT_CODEPAGE_JAPANESE, 15*MENU_CHAR_W, 4*CONIO_CHAR_H+MENU_CHAR_H*(1+id), 1/*white*/, 
            "R=%c%2d%c, G=%c%2d%c, B=%c%2d%c", 
            sel[0], (col>> 0)&0x1F, sel[1], 
            sel[2], (col>> 5)&0x1F, sel[3], 
            sel[4], (col>>10)&0x1F, sel[5]);
    }
}


void color_tester_menu(void)
{
    volatile unsigned short *vdp2_cram = (volatile unsigned short *)VDP2_CRAM;
    menu_settings_t* mset   = &_menu_settings;
    menu_items_t   * mitems = &_menu_items;
    int menu_selected = 16;

    _palmodif_col = 0;
    _palmodif_row = menu_selected;
    color_tester_keypress(NULL, 0, 0);

    while(1)
    {
        menu_reset_settings(mset);

        menu_set_logo_patterns(mset, LOGOPAT_GREYOUT, LOGOPAT_GREYOUT);

        menu_set_help(mset, "Arrows: Select Value, L/R: Tune Value");

        menu_set_callback_vblank(mset, background_vblank_clbk);
        menu_set_callback_keypress(mset, color_tester_keypress);

        menu_set_title(mset, "PalModif");
        menu_set_pos(mset, 2*CONIO_CHAR_W/*x0*/, 4*CONIO_CHAR_H/*y0*/, 13/*w*/, 0/*h*/, 1/*cols*/);
        //menu_set_erase_on_exit(mset, 1);
        menu_set_features(mset, MENU_FEATURES_CHANGEPAGE | MENU_FEATURES_TEXTCENTER);

        menu_reset_items(mitems);
        menu_add_item(mitems, "Title Back" , 0);
        menu_add_item(mitems, "Title Front", 1);
        menu_add_item(mitems, "Item Back"  , 2);
        menu_add_item(mitems, "Item Front" , 3);
        menu_add_item(mitems, "Grey #1"    , 4);
        menu_add_item(mitems, "Grey #2"    , 5);
        menu_add_item(mitems, "Border"     , 6);

        /* Display "ITEM" as grey out item, and "TITLE" as disabled item. */
        menu_add_item(mitems, "Disabled", 99); /* Disabled. */
        menu_add_item(mitems, "GreyOut" , MENU_TAG_GREYOUT);
        menu_disable_item(mitems, 99);

        menu_selected = menu_start(mitems, mset, menu_selected/*selected_tag*/);

        if(mset->exit_code == MENU_EXIT_CANCEL)
        {
            clear_screen();

            int i;
            for(i=3; i<26; i++)
            {
                conio_printf(2+1, i, COLOR_TRANSPARENT, empty_line);
            }
            return;
        }

        /* Select a new color. */
        //_palmodif_col = 0;
        _palmodif_row = menu_selected;

        unsigned short col = vdp2_cram[_palmodif_color_lut[_palmodif_row]];
        unsigned char rgb[3];

        rgb[0] = (col>> 0)&0x1F;
        rgb[1] = (col>> 5)&0x1F;
        rgb[2] = (col>>10)&0x1F;

        if(mset->exit_code == MENU_EXIT_NEXTPAGE_SHOULDER)
        {
            if(rgb[_palmodif_col] != 31)
            {
                rgb[_palmodif_col]++;
                vdp2_cram[_palmodif_color_lut[_palmodif_row]] = COLOR_RGB16(rgb[0], rgb[1], rgb[2]);
                // color_tester_keypress(NULL, 0, 0);
            }
        }
        else if(mset->exit_code == MENU_EXIT_PREVPAGE_SHOULDER)
        {
            if(rgb[_palmodif_col] != 0)
            {
                rgb[_palmodif_col]--;
                vdp2_cram[_palmodif_color_lut[_palmodif_row]] = COLOR_RGB16(rgb[0], rgb[1], rgb[2]);
                // color_tester_keypress(NULL, 0, 0);
            }
        }

        /* Refresh RGB values display. */
        color_tester_keypress(NULL, 0, 0);
    }
}

#endif // USE_COLOR_TESTER == 1
