/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#ifndef COMPAT_REPORT_H
#define COMPAT_REPORT_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Inclusion of compatibility report parts
 * shared with vmem.
 */
#include "compat_common.h"



/**
 * compat_init
 *
 * Initialize compatibility report related internals.
**/
void compat_init(void);


/**
 * compat_enable
 *
 * Enable compatibility reporter.
**/
void compat_enable(void);


/**
 * compat_buffer_append
 * Append formatted string to specified buffer.
 * (Prototype defined in compat_common.h)
 * void compat_buffer_append(char* buffer, char *string, ...);
 *
 * compat_print, compat_fl_print
 * Set compatibility report first line, which contains
 * compatibility report file name.
 *
 * compat_print
 * Append formatted string to temporary buffer.
**/
extern int _compat_enable;
extern int _compat_firstwrite;
extern char _compat_buffer[];
extern char _compat_fl_buffer[];


#define compat_fl_print(...) if(_compat_firstwrite == 0) {compat_buffer_append(_compat_fl_buffer, __VA_ARGS__);}
#define compat_print(...) compat_buffer_append(_compat_buffer, __VA_ARGS__);

/**
 * compat_flushbuffer
 *
 * Flush compatiblity report buffer to temporary file in SD card.
**/
void compat_flushbuffer(void);


/**
 * compat_finalize
 *
 * Prompt for feedback from user
 * and save compatibility report to its final location.
**/
#include "menu.h"
void compat_finalize(menu_settings_t* mset, menu_items_t* mitems);


#endif // COMPAT_REPORT_H
