/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#include "fonts.h"

/* Fonts declaration (see fonts_data.s). */
extern unsigned char _font_amiga12_dat;
extern unsigned char _font_amiga12_end;
extern unsigned char _font_harmonica_dat;
extern unsigned char _font_harmonica_end;
extern unsigned char _font_microknight_dat;
extern unsigned char _font_microknight_end;
extern unsigned char _font_mosoul_dat;
extern unsigned char _font_mosoul_end;
extern unsigned char _font_tandy_dat;
extern unsigned char _font_tandy_end;

/* Width table for each fonts. */
extern unsigned char _font_mosoul_wtbl_dat;
extern unsigned char _font_mosoul_wtbl_end;
extern unsigned char _font_microknight_wtbl_dat;
extern unsigned char _font_microknight_wtbl_end;
extern unsigned char _font_amiga12_wtbl_dat;
extern unsigned char _font_amiga12_wtbl_end;
extern unsigned char _font_harmonica_wtbl_dat;
extern unsigned char _font_harmonica_wtbl_end;
extern unsigned char _font_tandy_wtbl_dat;
extern unsigned char _font_tandy_wtbl_end;


unsigned char* font_get_ptr(int font_id)
{
    switch(font_id)
    {
    case(FONT_AMIGA12):
        return (unsigned char*)(&_font_amiga12_dat);
        break;

    case(FONT_HARMONICA):
        return (unsigned char*)(&_font_harmonica_dat);
        break;

    case(FONT_MICROKNIGHT):
        return (unsigned char*)(&_font_microknight_dat);
        break;

    case(FONT_MOSOUL):
        return (unsigned char*)(&_font_mosoul_dat);
        break;

    case(FONT_TANDY):
        return (unsigned char*)(&_font_tandy_dat);
        break;
    }

    return (unsigned char*)(&_font_mosoul_dat);
}

/* Extended fonts declaration (see fonts_data.s). */
extern unsigned char _font_katakana_dat;
extern unsigned char _font_latin_dat;

unsigned char* font_ext_ptr(int codepage)
{
    switch(codepage)
    {
    case(FONT_CODEPAGE_JAPANESE):
        return (unsigned char*)(&_font_katakana_dat);
        break;

    case(FONT_CODEPAGE_ENGLISH ):
    case(FONT_CODEPAGE_FRANCAIS):
    case(FONT_CODEPAGE_DEUTSCH ):
    case(FONT_CODEPAGE_ESPANOL ):
    case(FONT_CODEPAGE_ITALIANO):
        return (unsigned char*)(&_font_latin_dat);
        break;
    }

    return (unsigned char*)(&_font_latin_dat);
}

/* Return width for specified character. */
int font_get_prop_char_width(int font_id, int codepage, unsigned char c)
{
    int ret = CONIO_CHAR_W;
    if(c >= 0x80)
    {
        /* Fixed width for extended characters. */
        return ret;
    }

    switch(font_id)
    {
    case(FONT_AMIGA12):
        ret = ((unsigned char*)(&_font_amiga12_wtbl_dat))[c];
        break;

    case(FONT_HARMONICA):
        ret = ((unsigned char*)(&_font_harmonica_wtbl_dat))[c];
        break;

    case(FONT_MICROKNIGHT):
        ret = ((unsigned char*)(&_font_microknight_wtbl_dat))[c];
        break;

    case(FONT_MOSOUL):
        ret = ((unsigned char*)(&_font_mosoul_wtbl_dat))[c];
        break;

    case(FONT_TANDY):
        ret = ((unsigned char*)(&_font_tandy_wtbl_dat))[c];
        break;
    }

    return ret;
}
