/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#ifndef PSKAI_FLAGS_H
#define PSKAI_FLAGS_H


/**
 * Pseudo Saturn debug flags.
 *
 * Enable/disable incomplete and/or buggy Pseudo Saturn functions
 * until I finish to terminate them.
**/



/**
 * USE_ISOCUELOADER
 *
 * 0 : Don't use ISO/CUE loader, and reduce size of main executable.
 * 1 : Use ISO/CUE loader.
 *
 * (This feature is implemented in full firmware only)
**/
#ifndef USE_ISOCUELOADER
#   define USE_ISOCUELOADER 0
#endif // USE_ISOCUELOADER



/**
 * USE_VCDPLAY
 *
 * 0 : Don't use VCD playback.
 * 1 : Use VCD playback ... which doesn't works.
**/
#ifndef USE_VCDPLAY
#   define USE_VCDPLAY 0
#endif // USE_VCDPLAY



/**
 * USE_HEXEDIT
 *
 * 0 : Don't use hexedit, and reduce size of main executable.
 * 1 : Use hexedit.
**/
#ifndef USE_HEXEDIT
#   define USE_HEXEDIT 0
#endif // USE_HEXEDIT


/**
 * USE_COLOR_TESTER
 *
 * 0 : Don't use menu color tester feature.
 * 1 : Use menu color tester.
 *
 * Note : this is currently a debug feature hence should be disabled by default.
**/
#ifndef USE_COLOR_TESTER
#   define USE_COLOR_TESTER 1
#endif // USE_COLOR_TESTER


/**
 * USE_MINIPSEUDO
 *
 * 0 : Don't use minipseudo, and reduce size of main executable by around 0.3KB.
 * 1 : Use minipseudo.
**/
#ifndef USE_MINIPSEUDO
#   define USE_MINIPSEUDO 0
#endif // USE_MINIPSEUDO


#endif
