/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/
/*
 * Sega Saturn cartridge flash tool
 * by Anders Montonen, 2012
 *
 * Original software by ExCyber
 * Graphics routines by Charles MacDonald
 *
 * Creative Commons Attribution-ShareAlike 3.0 Unported (CC BY-SA 3.0)
 */
#ifndef _VDP_H_
#define _VDP_H_

/* VDP registers definitions. */
#include <sc_saturn.h>


/* Function prototypes */
void vdp_init(void);


/* Create a 5:5:5 RGB color with the MSB set */
#define COLOR(r,g,b) (((r)&0x1F) | ((g)&0x1F)<<5 | ((b)&0x1F)<<10|0x8000)
#define TRANSCOLOR   0x0000


/***********************************************************************
 * VDP1 Commands stuff                                                * 
***********************************************************************/
unsigned short vdp1_list_get_index(void);
void vdp1_list_set_index(unsigned short i);
void vdp1_list_start(void);

void vdp1_start(int buffer_count, int commands_count);
unsigned long vdp1_flip(void);


void vdp1_add_end(void);
void vdp1_add_system_clip(short x, short y);
void vdp1_add_user_clip(short x1, short y1, short x2, short y2);
void vdp1_add_local_coords(short x, short y);
void vdp1_add_polyline(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, unsigned short color);
void vdp1_add_polygon(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, unsigned short color, unsigned long grda, int mesh_use);

#define VDP_SPRITE_SIZE(W, H) (((((W)>>3)&0x3F)<<8)|((H)&0xFF))
void vdp1_add_distorted_sprite(short x1, short y1, short x2, short y2, short x3, short y3, short x4, short y4, unsigned short spr_size, unsigned long source, unsigned short grad, int mesh_use);



#endif /* _VDP_H_ */

