/**
 *  Pseudo Saturn Kai
 *  by cafe-alpha and Pseudo Saturn Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#include "compat_vmem.h"

#include <sc_saturn.h>


void compat_initbuffer(void)
{
    char* str = (char*)(VMEM_WORKRAM->file_entries);

    str[0] = '\0';
}


/* Pseudo Saturn Kai settings structure definition. */
#include "../pskai_settings.h"


void compat_vmem_write(char *string, ...)
{
    va_list argptr;
    pskai_settings_t* set = (pskai_settings_t*)(sc_settings_getptr()->extra_dat);
    char* str = (char*)(VMEM_WORKRAM->file_entries);
    int len;

    /* Write compatibility report string to buffer. */
    va_start(argptr, string);
    len = vsprintf(str, string, argptr);
    va_end(argptr);

    if(len <= 0)
    {
        return;
    }
    str[len] = '\0';

    /* Log compatibility message.
     * (may be useful in the future ?)
     */
    scd_logout("[compat]%s", str);

    /* Verify if compatibility reporter is enabled or not. */
    if(!set->compatrep_in_use)
    {
        return;
    }

    /* Append formatted message to compatibility report. */
    str[len++] = '\r';
    str[len++] = '\n';
    str[len  ] = '\0';
    scf_append((void*)str, (unsigned long)len, COMPAT_TEMP_DEV_ID, COMPAT_TEMP_FILE);
}

