/**
 *  Virtual Memory Cart for Pseudo Saturn Kai
 *  by cafe-alpha and Yabause Team.
 *  WWW: http://ppcenter.free.fr/pskai/
 *
 *  See LICENSE file for details.
**/

#ifndef _DEV_CART_H_
#define _DEV_CART_H_

#include <stdio.h>

/* Vmem structures and other misc. definitions. */
#include "vmem_defs.h"


/**
 * get_id_from_filename
 * Function common to both dev_cart and dev_floppy.
 *
 * Return file ID from its filename.
 * Negative value is returned when file name don't matches expected pattern
 *
 * Example : file_get_id("DATA123.ABC") returns 123
**/
short get_id_from_filename(char* name);


/**
 * file_idxglobal_getptr
 * Function common to both dev_cart and dev_floppy.
 *
 * Return pointer to device for file-based memory devices.
**/
vmem_idxglobal_t* file_idxglobal_getptr(void);



int FileBUPInit(void);


void CartBUPInit(void);

Sint32 CartBUPSelectPartition(Uint16 num);
Sint32 CartBUPFormat(void);
Sint32 CartBUPStatus(Uint32 datasize, BupStat *tb);
Sint32 CartBUPWrite(BupDir *tb, volatile Uint8 *data, Uint8 wmode);
Sint32 CartBUPRead(Uint8 *filename, volatile Uint8 *data);
Sint32 CartBUPDelete(Uint8 *filename);
Sint32 CartBUPDirectory(Uint8 *filename, Uint16 tbsize, BupDir *tb, Uint16 tbsize_bram);
Sint32 CartBUPVerify(Uint8 *filename, volatile Uint8 *data);

#endif // _DEV_CART_H_
